Statistics
| Branch: | Tag: | Revision:

root / Makefile.am @ 387863a5

History | View | Annotate | Download (42 kB)

1 e8230860 Michael Hanselmann
# Ganeti makefile
2 e8230860 Michael Hanselmann
# - Indent with tabs only.
3 e8230860 Michael Hanselmann
# - Keep files sorted; one line per file.
4 e8230860 Michael Hanselmann
# - Directories in lib/ must have their own *dir variable (see hypervisor).
5 e8230860 Michael Hanselmann
# - All directories must be listed DIRS.
6 0a7bed64 Michael Hanselmann
# - Use autogen.sh to generate Makefile.in and configure script.
7 e8230860 Michael Hanselmann
8 e8230860 Michael Hanselmann
# Automake doesn't export these variables before version 1.10.
9 e8230860 Michael Hanselmann
abs_top_builddir = @abs_top_builddir@
10 e8230860 Michael Hanselmann
abs_top_srcdir = @abs_top_srcdir@
11 e8230860 Michael Hanselmann
12 08366664 Michael Hanselmann
# Helper values for calling builtin functions
13 08366664 Michael Hanselmann
empty :=
14 08366664 Michael Hanselmann
space := $(empty) $(empty)
15 08366664 Michael Hanselmann
comma := ,
16 08366664 Michael Hanselmann
17 a01dd3c6 Iustin Pop
# Use bash in order to be able to use pipefail
18 a01dd3c6 Iustin Pop
SHELL=/bin/bash
19 a01dd3c6 Iustin Pop
20 6e06b36c Iustin Pop
ACLOCAL_AMFLAGS = -I autotools
21 4f3d5b76 Michael Hanselmann
BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 b959138f Michael Hanselmann
RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 eed5c5df Michael Hanselmann
CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 5d3c30df Michael Hanselmann
CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 c55cc346 Iustin Pop
CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 73d0e218 Iustin Pop
CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 96602be4 Michael Hanselmann
CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 7385c51d Michael Hanselmann
CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 f6cbcc06 Michael Hanselmann
CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 95eb4188 Michael Hanselmann
DOCPP = $(top_srcdir)/autotools/docpp
31 e8230860 Michael Hanselmann
REPLACE_VARS_SED = autotools/replace_vars.sed
32 d99d1e36 Iustin Pop
CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 d5a2a550 Michael Hanselmann
BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34 e8230860 Michael Hanselmann
35 22c5390d Iustin Pop
# Note: these are automake-specific variables, and must be named after
36 22c5390d Iustin Pop
# the directory + 'dir' suffix
37 2d48a3a2 Michael Hanselmann
clientdir = $(pkgpythondir)/client
38 e8230860 Michael Hanselmann
hypervisordir = $(pkgpythondir)/hypervisor
39 ff9efc03 Michael Hanselmann
httpdir = $(pkgpythondir)/http
40 dc101ecc Michael Hanselmann
masterddir = $(pkgpythondir)/masterd
41 12426ae1 Guido Trotter
confddir = $(pkgpythondir)/confd
42 8c229cc7 Oleksiy Mishchenko
rapidir = $(pkgpythondir)/rapi
43 899c4d2c Michael Hanselmann
serverdir = $(pkgpythondir)/server
44 9f4bb951 Michael Hanselmann
watcherdir = $(pkgpythondir)/watcher
45 bb44b1ae Michael Hanselmann
impexpddir = $(pkgpythondir)/impexpd
46 c047a981 Michael Hanselmann
utilsdir = $(pkgpythondir)/utils
47 e8230860 Michael Hanselmann
toolsdir = $(pkglibdir)/tools
48 7617fd6b Iustin Pop
iallocatorsdir = $(pkglibdir)/iallocators
49 0d2bf835 René Nussbaumer
pytoolsdir = $(pkgpythondir)/tools
50 e8230860 Michael Hanselmann
docdir = $(datadir)/doc/$(PACKAGE)
51 b8fe7ca6 Iustin Pop
myexeclibdir = $(pkglibdir)
52 e8230860 Michael Hanselmann
53 a4f12da4 Michael Hanselmann
# Delete output file if an error occurred while building it
54 a4f12da4 Michael Hanselmann
.DELETE_ON_ERROR:
55 a4f12da4 Michael Hanselmann
56 d5506465 Iustin Pop
HTOOLS_DIRS = \
57 d5506465 Iustin Pop
	htools \
58 d5506465 Iustin Pop
	htools/Ganeti \
59 358a0a8f Iustin Pop
	htools/Ganeti/Confd \
60 458a286a Iustin Pop
	htools/Ganeti/HTools \
61 458a286a Iustin Pop
	htools/Ganeti/HTools/Program
62 d5506465 Iustin Pop
63 e8230860 Michael Hanselmann
DIRS = \
64 e8230860 Michael Hanselmann
	autotools \
65 e8230860 Michael Hanselmann
	daemons \
66 e8230860 Michael Hanselmann
	devel \
67 e8230860 Michael Hanselmann
	doc \
68 e8230860 Michael Hanselmann
	doc/examples \
69 d6d9ce45 Guido Trotter
	doc/examples/hooks \
70 c51580b3 Guido Trotter
	doc/examples/gnt-debug \
71 d5506465 Iustin Pop
	$(HTOOLS_DIRS) \
72 e8230860 Michael Hanselmann
	lib \
73 2d48a3a2 Michael Hanselmann
	lib/client \
74 f9897b6d Michael Hanselmann
	lib/build \
75 2f16ea8f Michael Hanselmann
	lib/confd \
76 ff9efc03 Michael Hanselmann
	lib/http \
77 e8230860 Michael Hanselmann
	lib/hypervisor \
78 bb44b1ae Michael Hanselmann
	lib/impexpd \
79 dc101ecc Michael Hanselmann
	lib/masterd \
80 8c229cc7 Oleksiy Mishchenko
	lib/rapi \
81 899c4d2c Michael Hanselmann
	lib/server \
82 0d2bf835 René Nussbaumer
	lib/tools \
83 c047a981 Michael Hanselmann
	lib/utils \
84 9f4bb951 Michael Hanselmann
	lib/watcher \
85 e8230860 Michael Hanselmann
	man \
86 e8230860 Michael Hanselmann
	qa \
87 e8230860 Michael Hanselmann
	test \
88 e8230860 Michael Hanselmann
	test/data \
89 6bbd76d2 Iustin Pop
	test/data/htools \
90 91e5a351 Iustin Pop
	test/data/htools/rapi \
91 1e6fab60 Agata Murawska
	test/data/ovfdata \
92 d92518d3 Agata Murawska
	test/data/ovfdata/other \
93 e8230860 Michael Hanselmann
	tools
94 e8230860 Michael Hanselmann
95 2750b299 Michael Hanselmann
BUILDTIME_DIR_AUTOCREATE = \
96 c964d962 Michael Hanselmann
	scripts \
97 22c5390d Iustin Pop
	$(APIDOC_DIR) \
98 22c5390d Iustin Pop
	$(APIDOC_PY_DIR) \
99 22c5390d Iustin Pop
	$(APIDOC_HS_DIR) \
100 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti \
101 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/Confd \
102 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools \
103 458a286a Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools/Program \
104 22c5390d Iustin Pop
	$(COVERAGE_DIR) \
105 22c5390d Iustin Pop
	$(COVERAGE_PY_DIR) \
106 22c5390d Iustin Pop
	$(COVERAGE_HS_DIR) \
107 b91e9518 Iustin Pop
	.hpc
108 2750b299 Michael Hanselmann
109 2750b299 Michael Hanselmann
BUILDTIME_DIRS = \
110 2750b299 Michael Hanselmann
	$(BUILDTIME_DIR_AUTOCREATE) \
111 6b997854 Michael Hanselmann
	doc/html
112 6b997854 Michael Hanselmann
113 6b997854 Michael Hanselmann
DIRCHECK_EXCLUDE = \
114 6b997854 Michael Hanselmann
	$(BUILDTIME_DIRS) \
115 6b997854 Michael Hanselmann
	ganeti-[0-9]*.[0-9]*.[0-9]* \
116 6b997854 Michael Hanselmann
	doc/html/_*
117 6b997854 Michael Hanselmann
118 2750b299 Michael Hanselmann
all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
119 c964d962 Michael Hanselmann
120 22c5390d Iustin Pop
# some helper vars
121 22c5390d Iustin Pop
COVERAGE_DIR = doc/coverage
122 22c5390d Iustin Pop
COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
123 22c5390d Iustin Pop
COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
124 22c5390d Iustin Pop
APIDOC_DIR = doc/api
125 22c5390d Iustin Pop
APIDOC_PY_DIR = $(APIDOC_DIR)/py
126 22c5390d Iustin Pop
APIDOC_HS_DIR = $(APIDOC_DIR)/hs
127 22c5390d Iustin Pop
128 2ab2b9f5 Iustin Pop
MAINTAINERCLEANFILES = \
129 d17e74b4 Iustin Pop
	$(docpng) \
130 b76aac08 Michael Hanselmann
	$(maninput) \
131 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
132 84a12e40 Iustin Pop
	doc/news.rst \
133 7a03d293 Michael Hanselmann
	doc/upgrade.rst \
134 84a12e40 Iustin Pop
	vcs-version
135 2ab2b9f5 Iustin Pop
136 d17e74b4 Iustin Pop
maintainer-clean-local:
137 6b997854 Michael Hanselmann
	rm -rf $(BUILDTIME_DIRS)
138 d17e74b4 Iustin Pop
139 e8230860 Michael Hanselmann
CLEANFILES = \
140 2f16ea8f Michael Hanselmann
	$(addsuffix /*.py[co],$(DIRS)) \
141 d5506465 Iustin Pop
	$(addsuffix /*.hi,$(HTOOLS_DIRS)) \
142 d5506465 Iustin Pop
	$(addsuffix /*.o,$(HTOOLS_DIRS)) \
143 c964d962 Michael Hanselmann
	$(all_dirfiles) \
144 2d48a3a2 Michael Hanselmann
	$(PYTHON_BOOTSTRAP) \
145 f774bd03 Michael Hanselmann
	epydoc.conf \
146 e8230860 Michael Hanselmann
	autotools/replace_vars.sed \
147 f154a7a3 Michael Hanselmann
	daemons/daemon-util \
148 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner \
149 e8230860 Michael Hanselmann
	devel/upload \
150 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES) \
151 f72f8622 Iustin Pop
	doc/examples/bash_completion \
152 d5a2a550 Michael Hanselmann
	lib/_generated_rpc.py \
153 2ab2b9f5 Iustin Pop
	$(man_MANS) \
154 2ab2b9f5 Iustin Pop
	$(manhtml) \
155 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
156 dd1dfd9a Michael Hanselmann
	stamp-srclinks \
157 d6159933 Iustin Pop
	$(nodist_pkgpython_PYTHON) \
158 c3f67183 Iustin Pop
	$(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
159 3096524e Iustin Pop
	$(HS_BUILT_TEST_HELPERS) \
160 191ff68c Iustin Pop
	.hpc/*.mix htools/*.tix \
161 191ff68c Iustin Pop
	doc/hs-lint.html
162 e8230860 Michael Hanselmann
163 c964d962 Michael Hanselmann
# BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
164 c964d962 Michael Hanselmann
# it'll cause the target to rebuild every time.
165 dc7d2c49 Michael Hanselmann
BUILT_SOURCES = \
166 96a7481d Michael Hanselmann
  $(built_base_sources) \
167 96a7481d Michael Hanselmann
	$(BUILT_PYTHON_SOURCES) \
168 96a7481d Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
169 96a7481d Michael Hanselmann
170 96a7481d Michael Hanselmann
built_base_sources = \
171 dc7d2c49 Michael Hanselmann
	ganeti \
172 dd1dfd9a Michael Hanselmann
	stamp-srclinks \
173 96a7481d Michael Hanselmann
	$(all_dirfiles)
174 2d1f248e Michael Hanselmann
175 96a7481d Michael Hanselmann
built_python_base_sources = \
176 13aeae6a Iustin Pop
	lib/_autoconf.py \
177 96a7481d Michael Hanselmann
	lib/_vcsversion.py
178 96a7481d Michael Hanselmann
179 96a7481d Michael Hanselmann
BUILT_PYTHON_SOURCES = \
180 96a7481d Michael Hanselmann
	$(built_python_base_sources) \
181 d5a2a550 Michael Hanselmann
	lib/_generated_rpc.py
182 e8230860 Michael Hanselmann
183 96a7481d Michael Hanselmann
# Generating the RPC wrappers depends on many things, so make sure it's built at
184 96a7481d Michael Hanselmann
# the end of the built sources
185 96a7481d Michael Hanselmann
lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
186 96a7481d Michael Hanselmann
187 656a7fdf Iustin Pop
# these are all built from the underlying %.in sources
188 656a7fdf Iustin Pop
BUILT_EXAMPLES = \
189 656a7fdf Iustin Pop
	doc/examples/ganeti-kvm-poweroff.initd \
190 656a7fdf Iustin Pop
	doc/examples/ganeti.cron \
191 656a7fdf Iustin Pop
	doc/examples/ganeti.initd \
192 656a7fdf Iustin Pop
	doc/examples/gnt-config-backup \
193 656a7fdf Iustin Pop
	doc/examples/hooks/ipsec
194 656a7fdf Iustin Pop
195 08366664 Michael Hanselmann
nodist_pkgpython_PYTHON = \
196 08366664 Michael Hanselmann
	$(BUILT_PYTHON_SOURCES)
197 08366664 Michael Hanselmann
198 f9897b6d Michael Hanselmann
noinst_PYTHON = \
199 5f43f393 Michael Hanselmann
	lib/build/__init__.py \
200 7142485a Iustin Pop
	lib/build/sphinx_ext.py \
201 7142485a Iustin Pop
	lib/build/shell_example_lexer.py
202 f9897b6d Michael Hanselmann
203 e8230860 Michael Hanselmann
pkgpython_PYTHON = \
204 e8230860 Michael Hanselmann
	lib/__init__.py \
205 a8a76bc2 Guido Trotter
	lib/asyncnotifier.py \
206 e8230860 Michael Hanselmann
	lib/backend.py \
207 e8230860 Michael Hanselmann
	lib/bdev.py \
208 e8230860 Michael Hanselmann
	lib/bootstrap.py \
209 e8230860 Michael Hanselmann
	lib/cli.py \
210 e8230860 Michael Hanselmann
	lib/cmdlib.py \
211 cea881e5 Michael Hanselmann
	lib/compat.py \
212 e8230860 Michael Hanselmann
	lib/config.py \
213 e8230860 Michael Hanselmann
	lib/constants.py \
214 821d9e43 Michael Hanselmann
	lib/daemon.py \
215 e8230860 Michael Hanselmann
	lib/errors.py \
216 62e0e880 Iustin Pop
	lib/ht.py \
217 e8230860 Michael Hanselmann
	lib/jqueue.py \
218 8b537bb0 Michael Hanselmann
	lib/jstore.py \
219 e8230860 Michael Hanselmann
	lib/locking.py \
220 e8230860 Michael Hanselmann
	lib/luxi.py \
221 e8230860 Michael Hanselmann
	lib/mcpu.py \
222 a744b676 Manuel Franceschini
	lib/netutils.py \
223 e8230860 Michael Hanselmann
	lib/objects.py \
224 e8230860 Michael Hanselmann
	lib/opcodes.py \
225 ced78a66 Agata Murawska
	lib/ovf.py \
226 a123dc19 Michael Hanselmann
	lib/qlang.py \
227 4ca96421 Michael Hanselmann
	lib/query.py \
228 e8230860 Michael Hanselmann
	lib/rpc.py \
229 6648cb36 Michael Hanselmann
	lib/rpc_defs.py \
230 f12e1736 René Nussbaumer
	lib/runtime.py \
231 e8230860 Michael Hanselmann
	lib/serializer.py \
232 e8230860 Michael Hanselmann
	lib/ssconf.py \
233 e8230860 Michael Hanselmann
	lib/ssh.py \
234 ac2d0fe4 Michael Hanselmann
	lib/storage.py \
235 1338f2b4 Balazs Lecz
	lib/uidpool.py \
236 76094e37 Michael Hanselmann
	lib/workerpool.py
237 e8230860 Michael Hanselmann
238 2d48a3a2 Michael Hanselmann
client_PYTHON = \
239 c2855a12 Michael Hanselmann
	lib/client/__init__.py \
240 02266fe0 Michael Hanselmann
	lib/client/gnt_backup.py \
241 7b3e7d41 Michael Hanselmann
	lib/client/gnt_cluster.py \
242 6d50f5f9 Michael Hanselmann
	lib/client/gnt_debug.py \
243 667dbd6b Adeodato Simo
	lib/client/gnt_group.py \
244 e792102d Michael Hanselmann
	lib/client/gnt_instance.py \
245 a09b9e3d Michael Hanselmann
	lib/client/gnt_job.py \
246 37494fa4 Michael Hanselmann
	lib/client/gnt_node.py \
247 6d50f5f9 Michael Hanselmann
	lib/client/gnt_os.py
248 2d48a3a2 Michael Hanselmann
249 e8230860 Michael Hanselmann
hypervisor_PYTHON = \
250 e8230860 Michael Hanselmann
	lib/hypervisor/__init__.py \
251 e8230860 Michael Hanselmann
	lib/hypervisor/hv_base.py \
252 48297fa2 Iustin Pop
	lib/hypervisor/hv_chroot.py \
253 e8230860 Michael Hanselmann
	lib/hypervisor/hv_fake.py \
254 eb58f9b1 Guido Trotter
	lib/hypervisor/hv_kvm.py \
255 4b5e40a5 Iustin Pop
	lib/hypervisor/hv_lxc.py \
256 e8230860 Michael Hanselmann
	lib/hypervisor/hv_xen.py
257 e8230860 Michael Hanselmann
258 8c229cc7 Oleksiy Mishchenko
rapi_PYTHON = \
259 8c229cc7 Oleksiy Mishchenko
	lib/rapi/__init__.py \
260 10b207d4 Oleksiy Mishchenko
	lib/rapi/baserlib.py \
261 95ab4de9 David Knowles
	lib/rapi/client.py \
262 20b509de Michael Hanselmann
	lib/rapi/client_utils.py \
263 10b207d4 Oleksiy Mishchenko
	lib/rapi/connector.py \
264 a85f23fa Michael Hanselmann
	lib/rapi/rlib2.py \
265 a85f23fa Michael Hanselmann
	lib/rapi/testutils.py
266 8c229cc7 Oleksiy Mishchenko
267 ff9efc03 Michael Hanselmann
http_PYTHON = \
268 02cab3e7 Michael Hanselmann
	lib/http/__init__.py \
269 be500c29 Michael Hanselmann
	lib/http/auth.py \
270 02cab3e7 Michael Hanselmann
	lib/http/client.py \
271 02cab3e7 Michael Hanselmann
	lib/http/server.py
272 ff9efc03 Michael Hanselmann
273 12426ae1 Guido Trotter
confd_PYTHON = \
274 71f27d19 Guido Trotter
	lib/confd/__init__.py \
275 e4ccf6cd Guido Trotter
	lib/confd/client.py \
276 2f16ea8f Michael Hanselmann
	lib/confd/querylib.py \
277 2f16ea8f Michael Hanselmann
	lib/confd/server.py
278 8c229cc7 Oleksiy Mishchenko
279 dc101ecc Michael Hanselmann
masterd_PYTHON = \
280 033a1d00 Michael Hanselmann
	lib/masterd/__init__.py \
281 033a1d00 Michael Hanselmann
	lib/masterd/instance.py
282 dc101ecc Michael Hanselmann
283 bb44b1ae Michael Hanselmann
impexpd_PYTHON = \
284 bb44b1ae Michael Hanselmann
	lib/impexpd/__init__.py
285 bb44b1ae Michael Hanselmann
286 9f4bb951 Michael Hanselmann
watcher_PYTHON = \
287 9ca87fb3 Michael Hanselmann
	lib/watcher/__init__.py \
288 adf6301e Michael Hanselmann
	lib/watcher/nodemaint.py \
289 adf6301e Michael Hanselmann
	lib/watcher/state.py
290 9f4bb951 Michael Hanselmann
291 899c4d2c Michael Hanselmann
server_PYTHON = \
292 29d91329 Michael Hanselmann
	lib/server/__init__.py \
293 5c9c0e0e Michael Hanselmann
	lib/server/confd.py \
294 5119f2ec Michael Hanselmann
	lib/server/masterd.py \
295 d9c82a4e Michael Hanselmann
	lib/server/noded.py \
296 d9c82a4e Michael Hanselmann
	lib/server/rapi.py
297 899c4d2c Michael Hanselmann
298 0d2bf835 René Nussbaumer
pytools_PYTHON = \
299 0d2bf835 René Nussbaumer
	lib/tools/__init__.py \
300 0d2bf835 René Nussbaumer
	lib/tools/ensure_dirs.py
301 0d2bf835 René Nussbaumer
302 c047a981 Michael Hanselmann
utils_PYTHON = \
303 4fd029cf Michael Hanselmann
	lib/utils/__init__.py \
304 79d22269 Michael Hanselmann
	lib/utils/algo.py \
305 9d1b963f Michael Hanselmann
	lib/utils/filelock.py \
306 f21bb4b7 Michael Hanselmann
	lib/utils/hash.py \
307 3865ca48 Michael Hanselmann
	lib/utils/io.py \
308 1ae4c5a1 Michael Hanselmann
	lib/utils/log.py \
309 8dc76d54 Guido Trotter
	lib/utils/mlock.py \
310 17b97ab3 Michael Hanselmann
	lib/utils/nodesetup.py \
311 a4ccecf6 Michael Hanselmann
	lib/utils/process.py \
312 7fcffe27 Michael Hanselmann
	lib/utils/retry.py \
313 7831fc5f Michael Hanselmann
	lib/utils/text.py \
314 c50645c0 Michael Hanselmann
	lib/utils/wrapper.py \
315 c50645c0 Michael Hanselmann
	lib/utils/x509.py
316 c047a981 Michael Hanselmann
317 f05c99f3 Michael Hanselmann
docrst = \
318 ffa6869f Iustin Pop
	doc/admin.rst \
319 5c0c1eeb Iustin Pop
	doc/design-2.0.rst \
320 4f366caf Michael Hanselmann
	doc/design-2.1.rst \
321 e56bb0e8 Guido Trotter
	doc/design-2.2.rst \
322 1eb85930 Guido Trotter
	doc/design-2.3.rst \
323 92902e91 Iustin Pop
	doc/design-htools-2.3.rst \
324 78b40c5e Michael Hanselmann
	doc/design-2.4.rst \
325 d774ce92 Michael Hanselmann
	doc/design-2.5.rst \
326 c95c0f71 Michael Hanselmann
	doc/design-draft.rst \
327 1e86ee97 Marc Schmitt
	doc/design-oob.rst \
328 ae9b5e0f Tsachy Shacham
	doc/design-cpu-pinning.rst \
329 e5a246df Michael Hanselmann
	doc/design-query2.rst \
330 539f195a Michael Hanselmann
	doc/design-x509-ca.rst \
331 278ddaa9 Michael Hanselmann
	doc/design-http-server.rst \
332 1375e1d9 Michael Hanselmann
	doc/design-impexp2.rst \
333 ed9fda24 Michael Hanselmann
	doc/design-lu-generated-jobs.rst \
334 4055b109 Adeodato Simo
	doc/design-multi-reloc.rst \
335 eec83a95 Apollon Oikonomopoulos
	doc/design-network.rst \
336 6c3d18e0 Michael Hanselmann
	doc/design-chained-jobs.rst \
337 64ea845e Michael Hanselmann
	doc/design-ovf-support.rst \
338 d85f01e7 Iustin Pop
	doc/design-resource-model.rst \
339 d9bdffc3 René Nussbaumer
	doc/cluster-merge.rst \
340 a997cec5 Apollon Oikonomopoulos
	doc/design-shared-storage.rst \
341 23f0b93e René Nussbaumer
	doc/design-node-state-cache.rst \
342 6b898285 Iustin Pop
	doc/design-virtual-clusters.rst \
343 62947ebb Michael Hanselmann
	doc/devnotes.rst \
344 e2078d28 Iustin Pop
	doc/glossary.rst \
345 4d6443f4 Iustin Pop
	doc/hooks.rst \
346 876860a3 Iustin Pop
	doc/iallocator.rst \
347 d17e74b4 Iustin Pop
	doc/index.rst \
348 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
349 28e15341 Iustin Pop
	doc/install.rst \
350 9725b53d Michael Hanselmann
	doc/locking.rst \
351 6bf273d5 Michael Hanselmann
	doc/move-instance.rst \
352 c71a1a3d Iustin Pop
	doc/news.rst \
353 6d81475c Iustin Pop
	doc/rapi.rst \
354 b76aac08 Michael Hanselmann
	doc/security.rst \
355 35dd762d Michael Hanselmann
	doc/upgrade.rst \
356 c71a1a3d Iustin Pop
	doc/walkthrough.rst
357 f05c99f3 Michael Hanselmann
358 0985325d Iustin Pop
HS_PROGS = htools/htools
359 2922d2c5 René Nussbaumer
HS_BIN_ROLES = hbal hscan hspace hinfo
360 d6159933 Iustin Pop
361 73b0fa69 Iustin Pop
HS_ALL_PROGS = $(HS_PROGS) htools/test htools/hpc-htools htools/hconfd
362 c3f67183 Iustin Pop
HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
363 3096524e Iustin Pop
HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/%) test/hail
364 3096524e Iustin Pop
365 74e60746 Iustin Pop
HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
366 74e60746 Iustin Pop
# extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
367 d6159933 Iustin Pop
HEXTRA =
368 c7ec3025 Iustin Pop
# internal extra flags (used for htools/test mainly)
369 c7ec3025 Iustin Pop
HEXTRA_INT =
370 b91e9518 Iustin Pop
# exclude options for coverage reports
371 9822b1dd Iustin Pop
HPCEXCL = --exclude Main \
372 98b33d0e Iustin Pop
	--exclude Ganeti.Constants \
373 9822b1dd Iustin Pop
	--exclude Ganeti.THH \
374 9822b1dd Iustin Pop
	--exclude Ganeti.HTools.QC \
375 9822b1dd Iustin Pop
	--exclude Ganeti.HTools.QCHelper \
376 98b33d0e Iustin Pop
	--exclude Ganeti.HTools.Version
377 d6159933 Iustin Pop
378 c3f67183 Iustin Pop
HS_LIB_SRCS = \
379 d6159933 Iustin Pop
	htools/Ganeti/HTools/CLI.hs \
380 d6159933 Iustin Pop
	htools/Ganeti/HTools/Cluster.hs \
381 1adec4be Iustin Pop
	htools/Ganeti/HTools/Compat.hs \
382 d6159933 Iustin Pop
	htools/Ganeti/HTools/Container.hs \
383 d6159933 Iustin Pop
	htools/Ganeti/HTools/ExtLoader.hs \
384 d6159933 Iustin Pop
	htools/Ganeti/HTools/Group.hs \
385 d6159933 Iustin Pop
	htools/Ganeti/HTools/IAlloc.hs \
386 d6159933 Iustin Pop
	htools/Ganeti/HTools/Instance.hs \
387 f047f90f Iustin Pop
	htools/Ganeti/HTools/JSON.hs \
388 d6159933 Iustin Pop
	htools/Ganeti/HTools/Loader.hs \
389 d6159933 Iustin Pop
	htools/Ganeti/HTools/Luxi.hs \
390 d6159933 Iustin Pop
	htools/Ganeti/HTools/Node.hs \
391 d6159933 Iustin Pop
	htools/Ganeti/HTools/PeerMap.hs \
392 d6159933 Iustin Pop
	htools/Ganeti/HTools/QC.hs \
393 9822b1dd Iustin Pop
	htools/Ganeti/HTools/QCHelper.hs \
394 d6159933 Iustin Pop
	htools/Ganeti/HTools/Rapi.hs \
395 d6159933 Iustin Pop
	htools/Ganeti/HTools/Simu.hs \
396 d6159933 Iustin Pop
	htools/Ganeti/HTools/Text.hs \
397 d6159933 Iustin Pop
	htools/Ganeti/HTools/Types.hs \
398 d6159933 Iustin Pop
	htools/Ganeti/HTools/Utils.hs \
399 9f13be88 Iustin Pop
	htools/Ganeti/HTools/Program.hs \
400 458a286a Iustin Pop
	htools/Ganeti/HTools/Program/Hail.hs \
401 201b6c34 Iustin Pop
	htools/Ganeti/HTools/Program/Hbal.hs \
402 2922d2c5 René Nussbaumer
	htools/Ganeti/HTools/Program/Hinfo.hs \
403 7b695a0d Iustin Pop
	htools/Ganeti/HTools/Program/Hscan.hs \
404 1494a4cc Iustin Pop
	htools/Ganeti/HTools/Program/Hspace.hs \
405 0c37d1e4 Iustin Pop
	htools/Ganeti/BasicTypes.hs \
406 417cc253 Iustin Pop
	htools/Ganeti/Confd.hs \
407 358a0a8f Iustin Pop
	htools/Ganeti/Confd/Server.hs \
408 eaa64cd8 Iustin Pop
	htools/Ganeti/Config.hs \
409 6ec7a50e Iustin Pop
	htools/Ganeti/Daemon.hs \
410 21dc8694 Iustin Pop
	htools/Ganeti/Hash.hs \
411 d6159933 Iustin Pop
	htools/Ganeti/Jobs.hs \
412 ba4e38e8 Iustin Pop
	htools/Ganeti/Logging.hs \
413 d6159933 Iustin Pop
	htools/Ganeti/Luxi.hs \
414 b1e81520 Iustin Pop
	htools/Ganeti/Objects.hs \
415 e9aaa3c6 Iustin Pop
	htools/Ganeti/OpCodes.hs \
416 7946c25d Iustin Pop
	htools/Ganeti/Runtime.hs \
417 aa3adf35 Iustin Pop
	htools/Ganeti/Ssconf.hs \
418 e9aaa3c6 Iustin Pop
	htools/Ganeti/THH.hs
419 d6159933 Iustin Pop
420 d99d1e36 Iustin Pop
HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
421 c3f67183 Iustin Pop
HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
422 d6159933 Iustin Pop
423 c964d962 Michael Hanselmann
$(RUN_IN_TEMPDIR): | $(all_dirfiles)
424 c964d962 Michael Hanselmann
425 a2d917f3 Iustin Pop
# Note: we use here an order-only prerequisite, as the contents of
426 a2d917f3 Iustin Pop
# _autoconf.py are not actually influencing the html build output: it
427 a2d917f3 Iustin Pop
# has to exist in order for the sphinx module to be loaded
428 a2d917f3 Iustin Pop
# successfully, but we certainly don't want the docs to be rebuilt if
429 a2d917f3 Iustin Pop
# it changes
430 c964d962 Michael Hanselmann
doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
431 7142485a Iustin Pop
	$(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
432 7142485a Iustin Pop
	lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
433 08366664 Michael Hanselmann
	| $(BUILT_PYTHON_SOURCES)
434 d17e74b4 Iustin Pop
	@test -n "$(SPHINX)" || \
435 d17e74b4 Iustin Pop
	    { echo 'sphinx-build' not found during configure; exit 1; }
436 2750b299 Michael Hanselmann
	@mkdir_p@ $(dir $@)
437 e7f6524c Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
438 13de7d59 Michael Hanselmann
	    -d . \
439 d17e74b4 Iustin Pop
	    -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
440 d17e74b4 Iustin Pop
	    -D release="$(PACKAGE_VERSION)" \
441 13de7d59 Michael Hanselmann
	    $(abs_top_srcdir)/doc $(CURDIR)/doc/html
442 13de7d59 Michael Hanselmann
	rm -f doc/html/.buildinfo doc/html/objects.inv
443 13de7d59 Michael Hanselmann
	touch $@
444 13de7d59 Michael Hanselmann
445 c964d962 Michael Hanselmann
doc/html: doc/html/index.html
446 2ab2b9f5 Iustin Pop
447 cbf3d64b Michael Hanselmann
doc/install-quick.rst: INSTALL
448 b76aac08 Michael Hanselmann
doc/news.rst: NEWS
449 7a03d293 Michael Hanselmann
doc/upgrade.rst: UPGRADE
450 b76aac08 Michael Hanselmann
451 e8deef56 Michael Hanselmann
doc/install-quick.rst doc/news.rst doc/upgrade.rst:
452 cbf3d64b Michael Hanselmann
	set -e; \
453 cbf3d64b Michael Hanselmann
	{ echo '.. This file is automatically updated at build time from $<.'; \
454 cbf3d64b Michael Hanselmann
	  echo '.. Do not edit.'; \
455 cbf3d64b Michael Hanselmann
	  echo; \
456 cbf3d64b Michael Hanselmann
	  cat $<; \
457 cbf3d64b Michael Hanselmann
	} > $@
458 cbf3d64b Michael Hanselmann
459 b8195800 Iustin Pop
docdot = \
460 ca9ccea8 Michael Hanselmann
	doc/arch-2.0.dot \
461 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-acquire.dot \
462 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-release.dot
463 b8195800 Iustin Pop
464 d17e74b4 Iustin Pop
docpng = $(patsubst %.dot,%.png,$(docdot))
465 e8230860 Michael Hanselmann
466 7e1ccbe0 Michael Hanselmann
# Things to build but not to install (add it to EXTRA_DIST if it should be
467 7e1ccbe0 Michael Hanselmann
# distributed)
468 7e1ccbe0 Michael Hanselmann
noinst_DATA = \
469 7e1ccbe0 Michael Hanselmann
	devel/upload \
470 7e1ccbe0 Michael Hanselmann
	doc/html \
471 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES) \
472 7e1ccbe0 Michael Hanselmann
	doc/examples/bash_completion \
473 7e1ccbe0 Michael Hanselmann
	$(manhtml)
474 f29266b4 Iustin Pop
475 4f3d5b76 Michael Hanselmann
gnt_scripts = \
476 e8230860 Michael Hanselmann
	scripts/gnt-backup \
477 e8230860 Michael Hanselmann
	scripts/gnt-cluster \
478 e8230860 Michael Hanselmann
	scripts/gnt-debug \
479 667dbd6b Adeodato Simo
	scripts/gnt-group \
480 e8230860 Michael Hanselmann
	scripts/gnt-instance \
481 e8230860 Michael Hanselmann
	scripts/gnt-job \
482 e8230860 Michael Hanselmann
	scripts/gnt-node \
483 e8230860 Michael Hanselmann
	scripts/gnt-os
484 e8230860 Michael Hanselmann
485 0d2bf835 René Nussbaumer
PYTHON_BOOTSTRAP_SBIN = \
486 29d91329 Michael Hanselmann
	daemons/ganeti-masterd \
487 5119f2ec Michael Hanselmann
	daemons/ganeti-noded \
488 9f4bb951 Michael Hanselmann
	daemons/ganeti-watcher \
489 d9c82a4e Michael Hanselmann
	daemons/ganeti-rapi \
490 656a7fdf Iustin Pop
	$(gnt_scripts)
491 2d48a3a2 Michael Hanselmann
492 73b0fa69 Iustin Pop
if PY_CONFD
493 73b0fa69 Iustin Pop
PYTHON_BOOTSTRAP_SBIN += daemons/ganeti-confd
494 73b0fa69 Iustin Pop
endif
495 73b0fa69 Iustin Pop
496 0d2bf835 René Nussbaumer
PYTHON_BOOTSTRAP = \
497 0d2bf835 René Nussbaumer
	$(PYTHON_BOOTSTRAP_SBIN) \
498 0d2bf835 René Nussbaumer
	tools/ensure-dirs
499 0d2bf835 René Nussbaumer
500 a8c68e44 Michael Hanselmann
qa_scripts = \
501 a0c3e726 Michael Hanselmann
	qa/__init__.py \
502 a8c68e44 Michael Hanselmann
	qa/ganeti-qa.py \
503 a8c68e44 Michael Hanselmann
	qa/qa_cluster.py \
504 a8c68e44 Michael Hanselmann
	qa/qa_config.py \
505 a8c68e44 Michael Hanselmann
	qa/qa_daemon.py \
506 a8c68e44 Michael Hanselmann
	qa/qa_env.py \
507 a8c68e44 Michael Hanselmann
	qa/qa_error.py \
508 21bf2e2e Andrea Spadaccini
	qa/qa_group.py \
509 a8c68e44 Michael Hanselmann
	qa/qa_instance.py \
510 09470dd8 Michael Hanselmann
	qa/qa_job.py \
511 a8c68e44 Michael Hanselmann
	qa/qa_node.py \
512 a8c68e44 Michael Hanselmann
	qa/qa_os.py \
513 a8c68e44 Michael Hanselmann
	qa/qa_rapi.py \
514 a8c68e44 Michael Hanselmann
	qa/qa_tags.py \
515 a8c68e44 Michael Hanselmann
	qa/qa_utils.py
516 a8c68e44 Michael Hanselmann
517 d6159933 Iustin Pop
bin_SCRIPTS =
518 d6159933 Iustin Pop
if WANT_HTOOLS
519 c3f67183 Iustin Pop
bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
520 458a286a Iustin Pop
install-exec-hook:
521 458a286a Iustin Pop
	@mkdir_p@ $(DESTDIR)$(iallocatorsdir)
522 7fa52acd Iustin Pop
# FIXME: this is a hardcoded logic, instead of auto-resolving
523 7fa52acd Iustin Pop
	$(LN_S) -f ../../../bin/htools \
524 458a286a Iustin Pop
		   $(DESTDIR)$(iallocatorsdir)/hail
525 201b6c34 Iustin Pop
	for role in $(HS_BIN_ROLES); do \
526 7fa52acd Iustin Pop
		$(LN_S) -f htools \
527 201b6c34 Iustin Pop
			   $(DESTDIR)$(bindir)/$$role ; \
528 201b6c34 Iustin Pop
	done
529 73b0fa69 Iustin Pop
if HS_CONFD
530 73b0fa69 Iustin Pop
	mv $(DESTDIR)$(sbindir)/hconfd $(DESTDIR)$(sbindir)/ganeti-confd
531 73b0fa69 Iustin Pop
endif
532 d6159933 Iustin Pop
endif
533 d6159933 Iustin Pop
534 c3f67183 Iustin Pop
$(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
535 16a6192d Iustin Pop
	@if [ -z "$(HTOOLS)" ]; then \
536 16a6192d Iustin Pop
	  echo "Error: htools compilation disabled at configure time" 1>&2 ;\
537 16a6192d Iustin Pop
	  exit 1; \
538 16a6192d Iustin Pop
	fi
539 49e11c49 Iustin Pop
	@BINARY=$(@:htools/%=%); \
540 49e11c49 Iustin Pop
	if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
541 fd0bc853 Iustin Pop
	  echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
542 fd0bc853 Iustin Pop
	  exit 1; \
543 49e11c49 Iustin Pop
	fi
544 a593113c Iustin Pop
	rm -f $(@:htools/%=%).tix
545 49e11c49 Iustin Pop
	BINARY=$(@:htools/%=%); $(GHC) --make \
546 ef958f2a Iustin Pop
	  $(HFLAGS) \
547 1adec4be Iustin Pop
	  $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
548 ef958f2a Iustin Pop
	  -osuf $$BINARY.o -hisuf $$BINARY.hi \
549 c7ec3025 Iustin Pop
	  $(HEXTRA) $(HEXTRA_INT) $@
550 b91e9518 Iustin Pop
# for the htools/test binary, we need to enable profiling/coverage
551 c7ec3025 Iustin Pop
htools/test: HEXTRA_INT=-fhpc -Wwarn -fno-warn-missing-signatures \
552 b91e9518 Iustin Pop
	-fno-warn-monomorphism-restriction -fno-warn-orphans \
553 b91e9518 Iustin Pop
	-fno-warn-missing-methods -fno-warn-unused-imports
554 b91e9518 Iustin Pop
555 896b2850 Iustin Pop
# we compile the hpc-htools binary with the program coverage
556 896b2850 Iustin Pop
htools/hpc-htools: HEXTRA_INT=-fhpc
557 25cdf177 Iustin Pop
558 04d15e63 Iustin Pop
# test dependency
559 896b2850 Iustin Pop
htools/offline-tests.sh: htools/hpc-htools
560 04d15e63 Iustin Pop
561 c7ec3025 Iustin Pop
# rules for building profiling-enabled versions of the haskell
562 c7ec3025 Iustin Pop
# programs: hs-prof does the full two-step build, whereas
563 c7ec3025 Iustin Pop
# hs-prof-quick does only the final rebuild (hs-prof must have been
564 c7ec3025 Iustin Pop
# run before)
565 c7ec3025 Iustin Pop
.PHONY: hs-prof hs-prof-quick
566 c7ec3025 Iustin Pop
hs-prof:
567 c7ec3025 Iustin Pop
	$(MAKE) clean
568 c7ec3025 Iustin Pop
	$(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
569 c7ec3025 Iustin Pop
	rm -f $(HS_ALL_PROGS)
570 c7ec3025 Iustin Pop
	$(MAKE) hs-prof-quick
571 c7ec3025 Iustin Pop
572 c7ec3025 Iustin Pop
hs-prof-quick:
573 c7ec3025 Iustin Pop
	$(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
574 c7ec3025 Iustin Pop
575 da7e44ee Michael Hanselmann
dist_sbin_SCRIPTS = \
576 da7e44ee Michael Hanselmann
	tools/ganeti-listrunner
577 4f3d5b76 Michael Hanselmann
578 fc3fd894 Michael Hanselmann
nodist_sbin_SCRIPTS = \
579 0d2bf835 René Nussbaumer
	$(PYTHON_BOOTSTRAP_SBIN) \
580 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner
581 fc3fd894 Michael Hanselmann
582 73b0fa69 Iustin Pop
if HS_CONFD
583 73b0fa69 Iustin Pop
nodist_sbin_SCRIPTS += htools/hconfd
584 73b0fa69 Iustin Pop
endif
585 73b0fa69 Iustin Pop
586 cc120286 Bernardo Dal Seno
python_scripts = \
587 e8230860 Michael Hanselmann
	tools/burnin \
588 e8230860 Michael Hanselmann
	tools/cfgshell \
589 e8230860 Michael Hanselmann
	tools/cfgupgrade \
590 b5672ea0 Iustin Pop
	tools/cfgupgrade12 \
591 1f7d3f7d René Nussbaumer
	tools/cluster-merge \
592 4ef0399b Iustin Pop
	tools/confd-client \
593 d62cbd3a Michael Hanselmann
	tools/fmtjson \
594 ea5fd476 Iustin Pop
	tools/lvmstrap \
595 6bf273d5 Michael Hanselmann
	tools/move-instance \
596 ced78a66 Agata Murawska
	tools/ovfconverter \
597 05cd934d René Nussbaumer
	tools/setup-ssh \
598 ea5fd476 Iustin Pop
	tools/sanitize-config
599 e8230860 Michael Hanselmann
600 61631293 Stephen Shirley
dist_tools_SCRIPTS = \
601 cc120286 Bernardo Dal Seno
	$(python_scripts) \
602 2f4c951e Stephen Shirley
	tools/kvm-console-wrapper \
603 d9eefcfa Andrea Spadaccini
	tools/xm-console-wrapper \
604 d9eefcfa Andrea Spadaccini
	tools/master-ip-setup
605 61631293 Stephen Shirley
606 2d76b580 Michael Hanselmann
pkglib_python_scripts = \
607 c6ccba7e Michael Hanselmann
	daemons/import-export \
608 c6ccba7e Michael Hanselmann
	tools/check-cert-expired
609 2d76b580 Michael Hanselmann
610 0d2bf835 René Nussbaumer
nodist_pkglib_python_scripts = \
611 0d2bf835 René Nussbaumer
	tools/ensure-dirs
612 0d2bf835 René Nussbaumer
613 b8fe7ca6 Iustin Pop
myexeclib_SCRIPTS = \
614 2d76b580 Michael Hanselmann
	daemons/daemon-util \
615 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
616 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts)
617 f154a7a3 Michael Hanselmann
618 b8fe7ca6 Iustin Pop
nodist_myexeclib_SCRIPTS = \
619 0d2bf835 René Nussbaumer
	$(nodist_pkglib_python_scripts)
620 0d2bf835 René Nussbaumer
621 e8230860 Michael Hanselmann
EXTRA_DIST = \
622 e8230860 Michael Hanselmann
	NEWS \
623 7a03d293 Michael Hanselmann
	UPGRADE \
624 f774bd03 Michael Hanselmann
	epydoc.conf.in \
625 70c771f6 Michael Hanselmann
	pylintrc \
626 bb46a96c Michael Hanselmann
	autotools/build-bash-completion \
627 d5a2a550 Michael Hanselmann
	autotools/build-rpc \
628 5d3c30df Michael Hanselmann
	autotools/check-header \
629 eed5c5df Michael Hanselmann
	autotools/check-python-code \
630 f6cbcc06 Michael Hanselmann
	autotools/check-imports \
631 c55cc346 Iustin Pop
	autotools/check-man-dashes \
632 73d0e218 Iustin Pop
	autotools/check-man-warnings \
633 c81ed2b2 Michael Hanselmann
	autotools/check-news \
634 e627fe09 Michael Hanselmann
	autotools/check-tar \
635 96602be4 Michael Hanselmann
	autotools/check-version \
636 d99d1e36 Iustin Pop
	autotools/convert-constants \
637 95eb4188 Michael Hanselmann
	autotools/docpp \
638 27e336af Michael Hanselmann
	autotools/gen-coverage \
639 df69e0a0 Bernardo Dal Seno
	autotools/testrunner \
640 387863a5 Iustin Pop
	autotools/wrong-hardcoded-paths \
641 f3313af5 Guido Trotter
	$(RUN_IN_TEMPDIR) \
642 f154a7a3 Michael Hanselmann
	daemons/daemon-util.in \
643 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner.in \
644 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
645 e8230860 Michael Hanselmann
	devel/upload.in \
646 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup.in \
647 b8195800 Iustin Pop
	$(docdot) \
648 f727d134 Michael Hanselmann
	$(docpng) \
649 d17e74b4 Iustin Pop
	$(docrst) \
650 d17e74b4 Iustin Pop
	doc/conf.py \
651 d17e74b4 Iustin Pop
	doc/html \
652 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES:%=%.in) \
653 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default \
654 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default-debug \
655 d6d9ce45 Guido Trotter
	doc/examples/hooks/ethers \
656 89c04c2d Guido Trotter
	doc/examples/gnt-debug/README \
657 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay0.json \
658 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay50.json \
659 e4d452b4 Michael Hanselmann
	test/lockperf.py \
660 e8230860 Michael Hanselmann
	test/testutils.py \
661 e8230860 Michael Hanselmann
	test/mocks.py \
662 e8230860 Michael Hanselmann
	$(dist_TESTS) \
663 e8230860 Michael Hanselmann
	$(TEST_FILES) \
664 6be8e2bf Iustin Pop
	man/footer.rst \
665 6be8e2bf Iustin Pop
	$(manrst) \
666 f727d134 Michael Hanselmann
	$(maninput) \
667 39e0d19e Michael Hanselmann
	qa/qa-sample.json \
668 d6159933 Iustin Pop
	$(qa_scripts) \
669 c3f67183 Iustin Pop
	$(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
670 5a1e31b4 Iustin Pop
	$(HS_PROG_SRCS) \
671 04d15e63 Iustin Pop
	htools/lint-hints.hs \
672 04d15e63 Iustin Pop
	htools/cli-tests-defs.sh \
673 04d15e63 Iustin Pop
	htools/offline-test.sh
674 e8230860 Michael Hanselmann
675 e8230860 Michael Hanselmann
man_MANS = \
676 e8230860 Michael Hanselmann
	man/ganeti.7 \
677 bae7e531 Michael Hanselmann
	man/ganeti-cleaner.8 \
678 b7b7cda6 Guido Trotter
	man/ganeti-confd.8 \
679 da7e44ee Michael Hanselmann
	man/ganeti-listrunner.8 \
680 320d986d Iustin Pop
	man/ganeti-masterd.8 \
681 e8230860 Michael Hanselmann
	man/ganeti-noded.8 \
682 e8230860 Michael Hanselmann
	man/ganeti-os-interface.7 \
683 320d986d Iustin Pop
	man/ganeti-rapi.8 \
684 e8230860 Michael Hanselmann
	man/ganeti-watcher.8 \
685 e8230860 Michael Hanselmann
	man/gnt-backup.8 \
686 e8230860 Michael Hanselmann
	man/gnt-cluster.8 \
687 d3b4cf9f Iustin Pop
	man/gnt-debug.8 \
688 667dbd6b Adeodato Simo
	man/gnt-group.8 \
689 e8230860 Michael Hanselmann
	man/gnt-instance.8 \
690 d3b4cf9f Iustin Pop
	man/gnt-job.8 \
691 e8230860 Michael Hanselmann
	man/gnt-node.8 \
692 5a19bd35 Iustin Pop
	man/gnt-os.8 \
693 5a19bd35 Iustin Pop
	man/hail.1 \
694 5a19bd35 Iustin Pop
	man/hbal.1 \
695 e2bdaf25 René Nussbaumer
	man/hinfo.1 \
696 5a19bd35 Iustin Pop
	man/hscan.1 \
697 d26d808a Iustin Pop
	man/hspace.1 \
698 d26d808a Iustin Pop
	man/htools.1
699 e8230860 Michael Hanselmann
700 5a19bd35 Iustin Pop
manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
701 6be8e2bf Iustin Pop
manhtml = $(patsubst %.rst,%.html,$(manrst))
702 fcdb582d Michael Hanselmann
mangen = $(patsubst %.rst,%.gen,$(manrst))
703 25c92bc5 Michael Hanselmann
maninput = \
704 5a19bd35 Iustin Pop
	$(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
705 de8eea3e Iustin Pop
	$(patsubst %.html,%.html.in,$(manhtml)) \
706 fcdb582d Michael Hanselmann
	man/footer.man man/footer.html $(mangen)
707 e8230860 Michael Hanselmann
708 e8230860 Michael Hanselmann
TEST_FILES = \
709 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.0.txt \
710 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.3.txt \
711 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-disk.txt \
712 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip4.txt \
713 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip6.txt \
714 27e46076 Michael Hanselmann
	test/data/cert1.pem \
715 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-dummy0.txt \
716 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-ipv4.txt \
717 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-ipv6.txt \
718 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline-ipv4.txt \
719 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline-ipv6.txt \
720 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline.txt \
721 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo.txt \
722 d816408a Iustin Pop
	test/data/proc_drbd8.txt \
723 a6ac80db Iustin Pop
	test/data/proc_drbd80-emptyline.txt \
724 2d76b580 Michael Hanselmann
	test/data/proc_drbd83.txt \
725 7a380ddf René Nussbaumer
	test/data/proc_drbd83_sync.txt \
726 7a380ddf René Nussbaumer
	test/data/proc_drbd83_sync_krnl2.6.39.txt \
727 585c8187 Guido Trotter
	test/data/kvm_1.0_help.txt \
728 585c8187 Guido Trotter
	test/data/kvm_0.15.90_help.txt \
729 585c8187 Guido Trotter
	test/data/kvm_0.12.5_help.txt \
730 585c8187 Guido Trotter
	test/data/kvm_0.9.1_help.txt \
731 549071a0 Luca Bigliardi
	test/data/sys_drbd_usermode_helper.txt \
732 6bbd76d2 Iustin Pop
	test/data/htools/hail-alloc-drbd.json \
733 6bbd76d2 Iustin Pop
	test/data/htools/hail-change-group.json \
734 3e5012c6 Iustin Pop
	test/data/htools/hail-invalid-reloc.json \
735 6bbd76d2 Iustin Pop
	test/data/htools/hail-node-evac.json \
736 6bbd76d2 Iustin Pop
	test/data/htools/hail-reloc-drbd.json \
737 9915fb20 Iustin Pop
	test/data/htools/common-suffix.data \
738 9915fb20 Iustin Pop
	test/data/htools/invalid-node.data \
739 9915fb20 Iustin Pop
	test/data/htools/missing-resources.data \
740 55ffacfa Iustin Pop
	test/data/htools/rapi/groups.json \
741 55ffacfa Iustin Pop
	test/data/htools/rapi/info.json \
742 55ffacfa Iustin Pop
	test/data/htools/rapi/instances.json \
743 55ffacfa Iustin Pop
	test/data/htools/rapi/nodes.json \
744 1e6fab60 Agata Murawska
	test/data/ovfdata/compr_disk.vmdk.gz \
745 d92518d3 Agata Murawska
	test/data/ovfdata/config.ini \
746 1e6fab60 Agata Murawska
	test/data/ovfdata/corrupted_resources.ovf \
747 d92518d3 Agata Murawska
	test/data/ovfdata/empty.ini \
748 1e6fab60 Agata Murawska
	test/data/ovfdata/empty.ovf \
749 1e6fab60 Agata Murawska
	test/data/ovfdata/ganeti.mf \
750 1e6fab60 Agata Murawska
	test/data/ovfdata/ganeti.ovf \
751 1e6fab60 Agata Murawska
	test/data/ovfdata/gzip_disk.ovf \
752 1e6fab60 Agata Murawska
	test/data/ovfdata/new_disk.vmdk \
753 d92518d3 Agata Murawska
	test/data/ovfdata/no_disk.ini \
754 1e6fab60 Agata Murawska
	test/data/ovfdata/no_disk_in_ref.ovf \
755 d92518d3 Agata Murawska
	test/data/ovfdata/no_os.ini \
756 1e6fab60 Agata Murawska
	test/data/ovfdata/no_ovf.ova \
757 1e6fab60 Agata Murawska
	test/data/ovfdata/ova.ova \
758 1e6fab60 Agata Murawska
	test/data/ovfdata/second_disk.vmdk \
759 d92518d3 Agata Murawska
	test/data/ovfdata/rawdisk.raw \
760 d92518d3 Agata Murawska
	test/data/ovfdata/unsafe_path.ini \
761 1e6fab60 Agata Murawska
	test/data/ovfdata/virtualbox.ovf \
762 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_extension.ovd \
763 d92518d3 Agata Murawska
	test/data/ovfdata/wrong_config.ini \
764 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_manifest.mf \
765 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_manifest.ovf \
766 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_ova.ova \
767 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_xml.ovf \
768 d92518d3 Agata Murawska
	test/data/ovfdata/other/rawdisk.raw \
769 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.02.txt \
770 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.66-fail.txt \
771 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.66-ok.txt \
772 1a1e7ab3 Iustin Pop
	test/data/vgs-missing-pvs-2.02.02.txt \
773 1a1e7ab3 Iustin Pop
	test/data/vgs-missing-pvs-2.02.66.txt \
774 53d4cdf1 Iustin Pop
	test/import-export_unittest-helper \
775 30f2802f Iustin Pop
	test/gnt-cli.test \
776 30f2802f Iustin Pop
	test/ganeti-cli.test \
777 53d4cdf1 Iustin Pop
	test/htools-balancing.test \
778 53d4cdf1 Iustin Pop
	test/htools-basic.test \
779 53d4cdf1 Iustin Pop
	test/htools-dynutil.test \
780 53d4cdf1 Iustin Pop
	test/htools-excl.test \
781 53d4cdf1 Iustin Pop
	test/htools-hail.test \
782 53d4cdf1 Iustin Pop
	test/htools-hspace.test \
783 53d4cdf1 Iustin Pop
	test/htools-invalid.test \
784 53d4cdf1 Iustin Pop
	test/htools-multi-group.test \
785 53d4cdf1 Iustin Pop
	test/htools-no-backend.test \
786 53d4cdf1 Iustin Pop
	test/htools-rapi.test \
787 53d4cdf1 Iustin Pop
	test/htools-single-group.test \
788 53d4cdf1 Iustin Pop
	test/htools-text-backend.test
789 e8230860 Michael Hanselmann
790 e8c8cf1a Michael Hanselmann
python_tests = \
791 3ade0e0e Michael Hanselmann
	doc/examples/rapi_testutils.py \
792 17496050 Guido Trotter
	test/ganeti.asyncnotifier_unittest.py \
793 f942a838 Michael Hanselmann
	test/ganeti.backend_unittest.py \
794 6de7c41d Iustin Pop
	test/ganeti.bdev_unittest.py \
795 6de7c41d Iustin Pop
	test/ganeti.cli_unittest.py \
796 66d1f035 René Nussbaumer
	test/ganeti.client.gnt_cluster_unittest.py \
797 25ce3ec4 Michael Hanselmann
	test/ganeti.client.gnt_instance_unittest.py \
798 1118ec44 Guido Trotter
	test/ganeti.daemon_unittest.py \
799 6de7c41d Iustin Pop
	test/ganeti.cmdlib_unittest.py \
800 cea881e5 Michael Hanselmann
	test/ganeti.compat_unittest.py \
801 edf7d66e Iustin Pop
	test/ganeti.confd.client_unittest.py \
802 e8230860 Michael Hanselmann
	test/ganeti.config_unittest.py \
803 6de7c41d Iustin Pop
	test/ganeti.constants_unittest.py \
804 3bd19c66 Michael Hanselmann
	test/ganeti.errors_unittest.py \
805 e8230860 Michael Hanselmann
	test/ganeti.hooks_unittest.py \
806 ecdf0398 Michael Hanselmann
	test/ganeti.ht_unittest.py \
807 6de7c41d Iustin Pop
	test/ganeti.http_unittest.py \
808 b7d82e40 Iustin Pop
	test/ganeti.hypervisor_unittest.py \
809 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_chroot_unittest.py \
810 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_fake_unittest.py \
811 748e4b5a Michael Hanselmann
	test/ganeti.hypervisor.hv_kvm_unittest.py \
812 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_lxc_unittest.py \
813 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_xen_unittest.py \
814 bb44b1ae Michael Hanselmann
	test/ganeti.impexpd_unittest.py \
815 989a8bee Michael Hanselmann
	test/ganeti.jqueue_unittest.py \
816 e8230860 Michael Hanselmann
	test/ganeti.locking_unittest.py \
817 231db3a5 Michael Hanselmann
	test/ganeti.luxi_unittest.py \
818 033a1d00 Michael Hanselmann
	test/ganeti.masterd.instance_unittest.py \
819 407339d0 Michael Hanselmann
	test/ganeti.mcpu_unittest.py \
820 a744b676 Manuel Franceschini
	test/ganeti.netutils_unittest.py \
821 4c14965f Guido Trotter
	test/ganeti.objects_unittest.py \
822 c32b908e Michael Hanselmann
	test/ganeti.opcodes_unittest.py \
823 1e6fab60 Agata Murawska
	test/ganeti.ovf_unittest.py \
824 a123dc19 Michael Hanselmann
	test/ganeti.qlang_unittest.py \
825 4ca96421 Michael Hanselmann
	test/ganeti.query_unittest.py \
826 cfaeaaf7 Michael Hanselmann
	test/ganeti.rapi.baserlib_unittest.py \
827 95ab4de9 David Knowles
	test/ganeti.rapi.client_unittest.py \
828 4cbd4462 Oleksiy Mishchenko
	test/ganeti.rapi.resources_unittest.py \
829 6395cebb Michael Hanselmann
	test/ganeti.rapi.rlib2_unittest.py \
830 a85f23fa Michael Hanselmann
	test/ganeti.rapi.testutils_unittest.py \
831 33231500 Michael Hanselmann
	test/ganeti.rpc_unittest.py \
832 f12e1736 René Nussbaumer
	test/ganeti.runtime_unittest.py \
833 6de7c41d Iustin Pop
	test/ganeti.serializer_unittest.py \
834 6de7c41d Iustin Pop
	test/ganeti.ssh_unittest.py \
835 048eeb2b Iustin Pop
	test/ganeti.storage_unittest.py \
836 0d2bf835 René Nussbaumer
	test/ganeti.tools.ensure_dirs_unittest.py \
837 93be53da Balazs Lecz
	test/ganeti.uidpool_unittest.py \
838 4fd029cf Michael Hanselmann
	test/ganeti.utils.algo_unittest.py \
839 9d1b963f Michael Hanselmann
	test/ganeti.utils.filelock_unittest.py \
840 f21bb4b7 Michael Hanselmann
	test/ganeti.utils.hash_unittest.py \
841 3865ca48 Michael Hanselmann
	test/ganeti.utils.io_unittest.py \
842 b6fa9a44 Michael Hanselmann
	test/ganeti.utils.log_unittest.py \
843 8dc76d54 Guido Trotter
	test/ganeti.utils.mlock_unittest.py \
844 17b97ab3 Michael Hanselmann
	test/ganeti.utils.nodesetup_unittest.py \
845 a4ccecf6 Michael Hanselmann
	test/ganeti.utils.process_unittest.py \
846 79d22269 Michael Hanselmann
	test/ganeti.utils.retry_unittest.py \
847 7fcffe27 Michael Hanselmann
	test/ganeti.utils.text_unittest.py \
848 7831fc5f Michael Hanselmann
	test/ganeti.utils.wrapper_unittest.py \
849 c50645c0 Michael Hanselmann
	test/ganeti.utils.x509_unittest.py \
850 4fd029cf Michael Hanselmann
	test/ganeti.utils_unittest.py \
851 3f991867 Michael Hanselmann
	test/ganeti.workerpool_unittest.py \
852 a0c3e726 Michael Hanselmann
	test/qa.qa_config_unittest.py \
853 aefbe369 Michael Hanselmann
	test/cfgupgrade_unittest.py \
854 055f822b Michael Hanselmann
	test/docs_unittest.py \
855 4fd2660d Michael Hanselmann
	test/pycurl_reset_unittest.py \
856 055f822b Michael Hanselmann
	test/tempfile_fork_unittest.py
857 0d20cc42 Bernardo Dal Seno
if HAS_FAKEROOT
858 0d20cc42 Bernardo Dal Seno
python_tests += test/ganeti.utils.io_unittest-runasroot.py
859 0d20cc42 Bernardo Dal Seno
endif
860 e8230860 Michael Hanselmann
861 b91e9518 Iustin Pop
haskell_tests = htools/test
862 b91e9518 Iustin Pop
863 e8c8cf1a Michael Hanselmann
dist_TESTS = \
864 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
865 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
866 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
867 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
868 30f2802f Iustin Pop
	test/cli-test.bash \
869 e8c8cf1a Michael Hanselmann
	$(python_tests)
870 e8c8cf1a Michael Hanselmann
871 e8230860 Michael Hanselmann
nodist_TESTS =
872 d3cd5a3f Iustin Pop
check_SCRIPTS =
873 d3cd5a3f Iustin Pop
874 e5f6768c Iustin Pop
if WANT_HTOOLSTESTS
875 b91e9518 Iustin Pop
nodist_TESTS += $(haskell_tests)
876 04d15e63 Iustin Pop
dist_TESTS += htools/offline-test.sh
877 3096524e Iustin Pop
check_SCRIPTS += htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
878 b91e9518 Iustin Pop
endif
879 e8230860 Michael Hanselmann
880 e8230860 Michael Hanselmann
TESTS = $(dist_TESTS) $(nodist_TESTS)
881 e8230860 Michael Hanselmann
882 27e336af Michael Hanselmann
# Environment for all tests
883 27e336af Michael Hanselmann
PLAIN_TESTS_ENVIRONMENT = \
884 30f2802f Iustin Pop
	PYTHONPATH=. \
885 30f2802f Iustin Pop
	TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
886 30f2802f Iustin Pop
	PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
887 30f2802f Iustin Pop
	$(RUN_IN_TEMPDIR)
888 27e336af Michael Hanselmann
889 27e336af Michael Hanselmann
# Environment for tests run by automake
890 f848ac00 Michael Hanselmann
TESTS_ENVIRONMENT = \
891 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
892 6e06b36c Iustin Pop
893 eed5c5df Michael Hanselmann
all_python_code = \
894 01a3a718 Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
895 cc120286 Bernardo Dal Seno
	$(python_scripts) \
896 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
897 0d2bf835 René Nussbaumer
	$(nodist_pkglib_python_scripts) \
898 e8c8cf1a Michael Hanselmann
	$(python_tests) \
899 01a3a718 Michael Hanselmann
	$(pkgpython_PYTHON) \
900 2d48a3a2 Michael Hanselmann
	$(client_PYTHON) \
901 01a3a718 Michael Hanselmann
	$(hypervisor_PYTHON) \
902 01a3a718 Michael Hanselmann
	$(rapi_PYTHON) \
903 899c4d2c Michael Hanselmann
	$(server_PYTHON) \
904 0d2bf835 René Nussbaumer
	$(pytools_PYTHON) \
905 01a3a718 Michael Hanselmann
	$(http_PYTHON) \
906 01a3a718 Michael Hanselmann
	$(confd_PYTHON) \
907 dc101ecc Michael Hanselmann
	$(masterd_PYTHON) \
908 bb44b1ae Michael Hanselmann
	$(impexpd_PYTHON) \
909 c047a981 Michael Hanselmann
	$(utils_PYTHON) \
910 9f4bb951 Michael Hanselmann
	$(watcher_PYTHON) \
911 a8c68e44 Michael Hanselmann
	$(noinst_PYTHON) \
912 a8c68e44 Michael Hanselmann
	$(qa_scripts)
913 01a3a718 Michael Hanselmann
914 eed5c5df Michael Hanselmann
srclink_files = \
915 6be8e2bf Iustin Pop
	man/footer.rst \
916 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
917 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
918 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
919 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
920 30f2802f Iustin Pop
	test/cli-test.bash \
921 04d15e63 Iustin Pop
	htools/offline-test.sh \
922 d3cd5a3f Iustin Pop
	htools/cli-tests-defs.sh \
923 d6159933 Iustin Pop
	$(all_python_code) \
924 c3f67183 Iustin Pop
	$(HS_LIB_SRCS) $(HS_PROG_SRCS)
925 eed5c5df Michael Hanselmann
926 eed5c5df Michael Hanselmann
check_python_code = \
927 e4e7c7df Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
928 f6cbcc06 Michael Hanselmann
	$(CHECK_IMPORTS) \
929 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
930 95eb4188 Michael Hanselmann
	$(DOCPP) \
931 eed5c5df Michael Hanselmann
	$(all_python_code)
932 eed5c5df Michael Hanselmann
933 e4e7c7df Michael Hanselmann
lint_python_code = \
934 f60d352e Michael Hanselmann
	ganeti \
935 f1763373 Iustin Pop
	ganeti/http/server.py \
936 f60d352e Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
937 cc120286 Bernardo Dal Seno
	$(python_scripts) \
938 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
939 2cc8bdd0 Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
940 f6cbcc06 Michael Hanselmann
	$(CHECK_IMPORTS) \
941 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
942 95eb4188 Michael Hanselmann
	$(DOCPP) \
943 2cc8bdd0 Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
944 eed5c5df Michael Hanselmann
945 f6cbcc06 Michael Hanselmann
standalone_python_modules = \
946 f6cbcc06 Michael Hanselmann
	lib/rapi/client.py \
947 f6cbcc06 Michael Hanselmann
	tools/ganeti-listrunner
948 f6cbcc06 Michael Hanselmann
949 21bf2e2e Andrea Spadaccini
pep8_python_code = \
950 21bf2e2e Andrea Spadaccini
	ganeti \
951 21bf2e2e Andrea Spadaccini
	ganeti/http/server.py \
952 21bf2e2e Andrea Spadaccini
	$(dist_sbin_SCRIPTS) \
953 cc120286 Bernardo Dal Seno
	$(python_scripts) \
954 21bf2e2e Andrea Spadaccini
	$(pkglib_python_scripts) \
955 21bf2e2e Andrea Spadaccini
	$(BUILD_BASH_COMPLETION) \
956 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
957 21bf2e2e Andrea Spadaccini
	$(DOCPP) \
958 21bf2e2e Andrea Spadaccini
	$(PYTHON_BOOTSTRAP) \
959 21bf2e2e Andrea Spadaccini
	qa
960 21bf2e2e Andrea Spadaccini
961 571b34f8 Michael Hanselmann
test/daemon-util_unittest.bash: daemons/daemon-util
962 571b34f8 Michael Hanselmann
963 7172f605 Michael Hanselmann
test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
964 7172f605 Michael Hanselmann
965 26916aad Apollon Oikonomopoulos
tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
966 26916aad Apollon Oikonomopoulos
	sed -f $(REPLACE_VARS_SED) < $< > $@
967 26916aad Apollon Oikonomopoulos
	chmod +x $@
968 26916aad Apollon Oikonomopoulos
969 dbefcc7e Michael Hanselmann
devel/upload: devel/upload.in $(REPLACE_VARS_SED)
970 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
971 e8230860 Michael Hanselmann
	chmod u+x $@
972 e8230860 Michael Hanselmann
973 c964d962 Michael Hanselmann
daemons/%: daemons/%.in $(REPLACE_VARS_SED)
974 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
975 5c566e17 Michael Hanselmann
	chmod +x $@
976 e8230860 Michael Hanselmann
977 c964d962 Michael Hanselmann
doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
978 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
979 e8230860 Michael Hanselmann
980 c964d962 Michael Hanselmann
doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
981 a2442bf9 Luca Bigliardi
	sed -f $(REPLACE_VARS_SED) < $< > $@
982 a2442bf9 Luca Bigliardi
983 b959138f Michael Hanselmann
doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
984 88a6ca6f Michael Hanselmann
	lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
985 b959138f Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
986 4f3d5b76 Michael Hanselmann
987 f86e82ef Iustin Pop
doc/%.png: doc/%.dot
988 2ab2b9f5 Iustin Pop
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
989 f86e82ef Iustin Pop
	$(DOT) -Tpng -o $@ $<
990 f86e82ef Iustin Pop
991 de8eea3e Iustin Pop
man/footer.man: man/footer.rst
992 de8eea3e Iustin Pop
	@test -n "$(PANDOC)" || \
993 de8eea3e Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
994 de8eea3e Iustin Pop
	$(PANDOC) -f rst -t man -o $@ $<
995 de8eea3e Iustin Pop
996 6be8e2bf Iustin Pop
man/footer.html: man/footer.rst
997 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
998 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
999 6be8e2bf Iustin Pop
	$(PANDOC) -f rst -t html -o $@ $<
1000 6be8e2bf Iustin Pop
1001 7142485a Iustin Pop
man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1002 7142485a Iustin Pop
	lib/build/shell_example_lexer.py
1003 387863a5 Iustin Pop
	@echo "Checking $< for hardcoded paths..."
1004 387863a5 Iustin Pop
	@if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1005 387863a5 Iustin Pop
	  echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1006 387863a5 Iustin Pop
	  exit 1; \
1007 387863a5 Iustin Pop
	fi
1008 fcdb582d Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
1009 fcdb582d Michael Hanselmann
1010 5a19bd35 Iustin Pop
man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1011 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1012 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1013 a01dd3c6 Iustin Pop
	set -o pipefail ; \
1014 9c45babb Iustin Pop
	trap 'echo auto-removing $@; rm $@' EXIT; \
1015 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1016 9c45babb Iustin Pop
	  sed -e 's/\\@/@/g' > $@; \
1017 73d0e218 Iustin Pop
	if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1018 c55cc346 Iustin Pop
	$(CHECK_MAN_DASHES) $@; \
1019 9c45babb Iustin Pop
	trap - EXIT
1020 9c45babb Iustin Pop
1021 2ab2b9f5 Iustin Pop
1022 fcdb582d Michael Hanselmann
man/%.html.in: man/%.gen man/footer.html
1023 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1024 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1025 a01dd3c6 Iustin Pop
	set -o pipefail ; \
1026 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1027 6be8e2bf Iustin Pop
	  sed -e 's/\\@/@/g' > $@
1028 6be8e2bf Iustin Pop
1029 5a19bd35 Iustin Pop
man/%.1: man/%.1.in $(REPLACE_VARS_SED)
1030 5a19bd35 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1031 5a19bd35 Iustin Pop
1032 dbefcc7e Michael Hanselmann
man/%.7: man/%.7.in $(REPLACE_VARS_SED)
1033 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1034 e8230860 Michael Hanselmann
1035 dbefcc7e Michael Hanselmann
man/%.8: man/%.8.in $(REPLACE_VARS_SED)
1036 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1037 e8230860 Michael Hanselmann
1038 dbefcc7e Michael Hanselmann
man/%.html: man/%.html.in $(REPLACE_VARS_SED)
1039 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1040 f29266b4 Iustin Pop
1041 75f76703 Michael Hanselmann
epydoc.conf: epydoc.conf.in Makefile
1042 75f76703 Michael Hanselmann
	sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
1043 f774bd03 Michael Hanselmann
1044 84a12e40 Iustin Pop
vcs-version:
1045 84a12e40 Iustin Pop
	if test -d .git; then \
1046 84a12e40 Iustin Pop
	  git describe > $@; \
1047 84a12e40 Iustin Pop
	elif test ! -f $@ ; then \
1048 84a12e40 Iustin Pop
	  echo "Cannot auto-generate $@ file"; exit 1; \
1049 84a12e40 Iustin Pop
	fi
1050 84a12e40 Iustin Pop
1051 84a12e40 Iustin Pop
.PHONY: regen-vcs-version
1052 84a12e40 Iustin Pop
regen-vcs-version:
1053 e8230860 Michael Hanselmann
	set -e; \
1054 84a12e40 Iustin Pop
	cd $(srcdir); \
1055 84a12e40 Iustin Pop
	if test -d .git; then \
1056 84a12e40 Iustin Pop
	  rm -f vcs-version; \
1057 84a12e40 Iustin Pop
	  $(MAKE) vcs-version; \
1058 84a12e40 Iustin Pop
	fi
1059 84a12e40 Iustin Pop
1060 d6159933 Iustin Pop
htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
1061 d6159933 Iustin Pop
	set -e; \
1062 d6159933 Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1063 d6159933 Iustin Pop
	sed -e "s/%ver%/$$VCSVER/" < $< > $@
1064 d6159933 Iustin Pop
1065 d99d1e36 Iustin Pop
htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1066 f11e524b Iustin Pop
	lib/constants.py lib/_autoconf.py lib/luxi.py \
1067 f11e524b Iustin Pop
	$(CONVERT_CONSTANTS) \
1068 ef958f2a Iustin Pop
	| lib/_vcsversion.py
1069 11fd5a86 Iustin Pop
	set -e; \
1070 876f6a5e Iustin Pop
	{ cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1071 d99d1e36 Iustin Pop
1072 13aeae6a Iustin Pop
lib/_autoconf.py: Makefile | lib/.dir
1073 84a12e40 Iustin Pop
	set -e; \
1074 e8230860 Michael Hanselmann
	{ echo '# This file is automatically generated, do not edit!'; \
1075 e8230860 Michael Hanselmann
	  echo '#'; \
1076 67047322 Iustin Pop
	  echo ''; \
1077 67047322 Iustin Pop
	  echo '"""Build-time configuration for Ganeti.'; \
1078 67047322 Iustin Pop
	  echo '';\
1079 67047322 Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
1080 67047322 Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
1081 67047322 Iustin Pop
	  echo 'not edit by hand).'; \
1082 67047322 Iustin Pop
	  echo ''; \
1083 67047322 Iustin Pop
	  echo '"""'; \
1084 67047322 Iustin Pop
	  echo ''; \
1085 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0301,C0324'; \
1086 0a4e7f24 Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
1087 0a4e7f24 Iustin Pop
	  echo '# style warnings' ; \
1088 0a4e7f24 Iustin Pop
	  echo ''; \
1089 e8230860 Michael Hanselmann
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1090 e8230860 Michael Hanselmann
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1091 e8230860 Michael Hanselmann
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1092 e8230860 Michael Hanselmann
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1093 e8230860 Michael Hanselmann
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1094 e8230860 Michael Hanselmann
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1095 e8230860 Michael Hanselmann
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1096 e8230860 Michael Hanselmann
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
1097 553bd93f Vitaly Kuznetsov
	  echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1098 e8230860 Michael Hanselmann
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1099 e8230860 Michael Hanselmann
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1100 2f2dbb4b Jun Futagawa
	  echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1101 e8230860 Michael Hanselmann
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1102 e8230860 Michael Hanselmann
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1103 b8203e1e Iustin Pop
	  echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1104 e8230860 Michael Hanselmann
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1105 cb7c0198 Iustin Pop
	  echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1106 4b97f902 Apollon Oikonomopoulos
	  echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1107 4b97f902 Apollon Oikonomopoulos
	  echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1108 e8230860 Michael Hanselmann
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1109 7e2c5b9e Guido Trotter
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
1110 c4dfb0b6 Andrea Spadaccini
	  echo "IP_PATH = '$(IP_PATH)'"; \
1111 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_PATH = '$(SOCAT)'"; \
1112 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1113 e90739d6 Michael Hanselmann
	  echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1114 bea60381 Michael Hanselmann
	  echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1115 bea60381 Michael Hanselmann
	  echo "TOOLSDIR = '$(toolsdir)'"; \
1116 4f3d5b76 Michael Hanselmann
	  echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1117 f154a7a3 Michael Hanselmann
	  echo "PKGLIBDIR = '$(pkglibdir)'"; \
1118 8a69b3a8 Andrea Spadaccini
	  echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1119 8a69b3a8 Andrea Spadaccini
	  echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1120 551b6283 Iustin Pop
	  echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1121 8b72b05c René Nussbaumer
	  echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1122 f12e1736 René Nussbaumer
	  echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1123 8b72b05c René Nussbaumer
	  echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1124 f12e1736 René Nussbaumer
	  echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1125 8b72b05c René Nussbaumer
	  echo "RAPI_USER = '$(RAPI_USER)'"; \
1126 f12e1736 René Nussbaumer
	  echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1127 f12e1736 René Nussbaumer
	  echo "CONFD_USER = '$(CONFD_USER)'"; \
1128 f12e1736 René Nussbaumer
	  echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1129 f12e1736 René Nussbaumer
	  echo "NODED_USER = '$(NODED_USER)'"; \
1130 03881cb0 René Nussbaumer
	  echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1131 3536c792 Iustin Pop
	  echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1132 a002ed79 Agata Murawska
	  echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1133 e5395072 Iustin Pop
	  if [ "$(HTOOLS)" ]; then \
1134 e5395072 Iustin Pop
	    echo "HTOOLS = True"; \
1135 e5395072 Iustin Pop
	  else \
1136 e5395072 Iustin Pop
	    echo "HTOOLS = False"; \
1137 e5395072 Iustin Pop
	  fi; \
1138 cd8b0072 Iustin Pop
	  echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1139 73b0fa69 Iustin Pop
	  echo "PY_CONFD = $(PY_CONFD)"; \
1140 73b0fa69 Iustin Pop
	  echo "HS_CONFD = $(HS_CONFD)"; \
1141 e8230860 Michael Hanselmann
	} > $@
1142 e8230860 Michael Hanselmann
1143 13aeae6a Iustin Pop
lib/_vcsversion.py: Makefile vcs-version | lib/.dir
1144 13aeae6a Iustin Pop
	set -e; \
1145 13aeae6a Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1146 13aeae6a Iustin Pop
	{ echo '# This file is automatically generated, do not edit!'; \
1147 13aeae6a Iustin Pop
	  echo '#'; \
1148 13aeae6a Iustin Pop
	  echo ''; \
1149 13aeae6a Iustin Pop
	  echo '"""Build-time VCS version number for Ganeti.'; \
1150 13aeae6a Iustin Pop
	  echo '';\
1151 13aeae6a Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
1152 13aeae6a Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
1153 13aeae6a Iustin Pop
	  echo 'not edit by hand).'; \
1154 13aeae6a Iustin Pop
	  echo ''; \
1155 13aeae6a Iustin Pop
	  echo '"""'; \
1156 13aeae6a Iustin Pop
	  echo ''; \
1157 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0301,C0324'; \
1158 13aeae6a Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
1159 13aeae6a Iustin Pop
	  echo '# style warnings' ; \
1160 13aeae6a Iustin Pop
	  echo ''; \
1161 13aeae6a Iustin Pop
	  echo "VCS_VERSION = '$$VCSVER'"; \
1162 13aeae6a Iustin Pop
	} > $@
1163 13aeae6a Iustin Pop
1164 96a7481d Michael Hanselmann
lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1165 96a7481d Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1166 d5a2a550 Michael Hanselmann
1167 dbefcc7e Michael Hanselmann
$(REPLACE_VARS_SED): Makefile
1168 e8230860 Michael Hanselmann
	set -e; \
1169 e8230860 Michael Hanselmann
	{ echo 's#@PREFIX@#$(prefix)#g'; \
1170 e8230860 Michael Hanselmann
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1171 e8230860 Michael Hanselmann
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1172 7a2ba406 Luca Bigliardi
	  echo 's#@BINDIR@#$(bindir)#g'; \
1173 e8230860 Michael Hanselmann
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
1174 e8230860 Michael Hanselmann
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1175 2f2dbb4b Jun Futagawa
	  echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1176 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1177 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1178 56956bcb Iustin Pop
	  echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1179 56956bcb Iustin Pop
	  echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1180 d3b4cf9f Iustin Pop
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1181 7e1fac25 Michael Hanselmann
	  echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1182 c5159571 Iustin Pop
	  echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1183 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1184 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1185 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1186 0d150c50 René Nussbaumer
	  echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1187 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1188 0d150c50 René Nussbaumer
	  echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1189 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1190 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1191 46a8da3b René Nussbaumer
	  echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1192 cd8b0072 Iustin Pop
	  echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1193 e8230860 Michael Hanselmann
	} > $@
1194 e8230860 Michael Hanselmann
1195 67313146 Michael Hanselmann
# Using deferred evaluation
1196 899c4d2c Michael Hanselmann
daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1197 9f4bb951 Michael Hanselmann
daemons/ganeti-watcher: MODULE = ganeti.watcher
1198 67313146 Michael Hanselmann
scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1199 0d2bf835 René Nussbaumer
tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1200 3096524e Iustin Pop
$(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/%,%,$@)
1201 67313146 Michael Hanselmann
1202 c964d962 Michael Hanselmann
$(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
1203 67313146 Michael Hanselmann
	test -n "$(MODULE)" || { echo Missing module; exit 1; }
1204 2d48a3a2 Michael Hanselmann
	set -e; \
1205 d75e738e Michael Hanselmann
	{ echo '#!/usr/bin/python'; \
1206 2d48a3a2 Michael Hanselmann
	  echo '# This file is automatically generated, do not edit!'; \
1207 67313146 Michael Hanselmann
	  echo "# Edit $(MODULE) instead."; \
1208 2d48a3a2 Michael Hanselmann
	  echo; \
1209 67313146 Michael Hanselmann
	  echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1210 2d48a3a2 Michael Hanselmann
	  echo; \
1211 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0103'; \
1212 2d48a3a2 Michael Hanselmann
	  echo '# C0103: Invalid name'; \
1213 2d48a3a2 Michael Hanselmann
	  echo; \
1214 2d48a3a2 Michael Hanselmann
	  echo 'import sys'; \
1215 67313146 Michael Hanselmann
	  echo 'import $(MODULE) as main'; \
1216 2d48a3a2 Michael Hanselmann
	  echo; \
1217 2d48a3a2 Michael Hanselmann
	  echo '# Temporarily alias commands until bash completion'; \
1218 2d48a3a2 Michael Hanselmann
	  echo '# generator is changed'; \
1219 67313146 Michael Hanselmann
	  echo 'if hasattr(main, "commands"):'; \
1220 55766d34 Andrea Spadaccini
	  echo '  commands = main.commands # pylint: disable=E1101'; \
1221 3f42b4f6 Michael Hanselmann
	  echo 'if hasattr(main, "aliases"):'; \
1222 55766d34 Andrea Spadaccini
	  echo '  aliases = main.aliases # pylint: disable=E1101'; \
1223 2d48a3a2 Michael Hanselmann
	  echo; \
1224 2d48a3a2 Michael Hanselmann
	  echo 'if __name__ == "__main__":'; \
1225 67313146 Michael Hanselmann
	  echo '  sys.exit(main.Main())'; \
1226 2d48a3a2 Michael Hanselmann
	} > $@
1227 2d48a3a2 Michael Hanselmann
	chmod u+x $@
1228 2d48a3a2 Michael Hanselmann
1229 3096524e Iustin Pop
$(HS_BUILT_TEST_HELPERS): Makefile
1230 3096524e Iustin Pop
	@test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1231 3096524e Iustin Pop
	set -e; \
1232 3096524e Iustin Pop
	{ echo '#!/bin/sh'; \
1233 3096524e Iustin Pop
	  echo '# This file is automatically generated, do not edit!'; \
1234 3096524e Iustin Pop
	  echo "# Edit Makefile.am instead."; \
1235 3096524e Iustin Pop
	  echo; \
1236 3096524e Iustin Pop
	  echo "HTOOLS=$(TESTROLE) exec ./htools/hpc-htools \"\$$@\""; \
1237 3096524e Iustin Pop
	} > $@
1238 3096524e Iustin Pop
	chmod u+x $@
1239 3096524e Iustin Pop
1240 e8230860 Michael Hanselmann
# We need to create symlinks because "make distcheck" will not install Python
1241 e8230860 Michael Hanselmann
# files when building.
1242 c964d962 Michael Hanselmann
stamp-srclinks: Makefile | $(all_dirfiles)
1243 e8230860 Michael Hanselmann
	set -e; \
1244 01a3a718 Michael Hanselmann
	for i in $(srclink_files); do \
1245 e8230860 Michael Hanselmann
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1246 e8230860 Michael Hanselmann
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
1247 e8230860 Michael Hanselmann
		fi; \
1248 e8230860 Michael Hanselmann
	done
1249 dd1dfd9a Michael Hanselmann
	touch $@
1250 97a37b3f Michael Hanselmann
1251 9ff7e35c Michael Hanselmann
.PHONY: ganeti
1252 9ff7e35c Michael Hanselmann
ganeti:
1253 01f3e7b1 Iustin Pop
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1254 9ff7e35c Michael Hanselmann
1255 6b997854 Michael Hanselmann
.PHONY: check-dirs
1256 6b997854 Michael Hanselmann
check-dirs: $(BUILT_SOURCES)
1257 0c1103d6 Iustin Pop
	@set -e; \
1258 6b997854 Michael Hanselmann
	find . -type d \( \( -name . \) -o \( \
1259 6b997854 Michael Hanselmann
		-name .git -o \
1260 6b997854 Michael Hanselmann
		-name autom4te.cache \
1261 6b997854 Michael Hanselmann
		\) -prune -o -print \) | { \
1262 6b997854 Michael Hanselmann
		error=; \
1263 6b997854 Michael Hanselmann
		while read dir; do \
1264 6b997854 Michael Hanselmann
			case "$$dir" in \
1265 6b997854 Michael Hanselmann
				$(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1266 6b997854 Michael Hanselmann
				*) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1267 6b997854 Michael Hanselmann
			esac; \
1268 6b997854 Michael Hanselmann
		done; \
1269 6b997854 Michael Hanselmann
		for dir in $(DIRS); do \
1270 6b997854 Michael Hanselmann
			if ! test -d "$$dir"; then \
1271 6b997854 Michael Hanselmann
				echo "Directory $$dir listed in DIRS does not exist" >&2; \
1272 6b997854 Michael Hanselmann
				error=1; \
1273 6b997854 Michael Hanselmann
			fi \
1274 6b997854 Michael Hanselmann
		done; \
1275 6b997854 Michael Hanselmann
		if test -n "$$error"; then exit 1; else exit 0; fi; \
1276 6b997854 Michael Hanselmann
	}
1277 6b997854 Michael Hanselmann
1278 f6cbcc06 Michael Hanselmann
.PHONY: check-local
1279 f6cbcc06 Michael Hanselmann
check-local: check-dirs $(BUILT_SOURCES)
1280 eed5c5df Michael Hanselmann
	$(CHECK_PYTHON_CODE) $(check_python_code)
1281 5d3c30df Michael Hanselmann
	PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1282 35576615 Michael Hanselmann
	$(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1283 7385c51d Michael Hanselmann
	$(CHECK_NEWS) < $(top_srcdir)/NEWS
1284 83ea5145 Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1285 9488fd1d Michael Hanselmann
	expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1286 154d7ba5 Michael Hanselmann
	if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1287 9488fd1d Michael Hanselmann
		echo "Incorrect version in README, expected $$expver"; \
1288 9488fd1d Michael Hanselmann
		exit 1; \
1289 7ecb3d0e Michael Hanselmann
	fi; \
1290 d5114fa1 Michael Hanselmann
	for file in doc/iallocator.rst doc/hooks.rst; do \
1291 d5114fa1 Michael Hanselmann
		if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1292 9822b1dd Iustin Pop
			"Documents Ganeti version $$expver"; then \
1293 d5114fa1 Michael Hanselmann
			echo "Incorrect version in $$file, expected $$expver"; \
1294 d5114fa1 Michael Hanselmann
			exit 1; \
1295 d5114fa1 Michael Hanselmann
		fi; \
1296 d5114fa1 Michael Hanselmann
	done
1297 eed5c5df Michael Hanselmann
1298 49e11c49 Iustin Pop
.PHONY: hs-check
1299 3096524e Iustin Pop
hs-check: htools/test htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
1300 49e11c49 Iustin Pop
	@rm -f test.tix
1301 49e11c49 Iustin Pop
	./htools/test
1302 896b2850 Iustin Pop
	HBINARY="./htools/hpc-htools" ./htools/offline-test.sh
1303 49e11c49 Iustin Pop
1304 08366664 Michael Hanselmann
# E111: indentation is not a multiple of four
1305 08366664 Michael Hanselmann
# E261: at least two spaces before inline comment
1306 08366664 Michael Hanselmann
# E501: line too long (80 characters)
1307 08366664 Michael Hanselmann
PEP8_IGNORE = E111,E261,E501
1308 08366664 Michael Hanselmann
1309 08366664 Michael Hanselmann
# For excluding pep8 expects filenames only, not whole paths
1310 08366664 Michael Hanselmann
PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1311 08366664 Michael Hanselmann
1312 e0098923 Iustin Pop
.PHONY: lint
1313 c964d962 Michael Hanselmann
lint: $(BUILT_SOURCES)
1314 6d7cc5ff Michael Hanselmann
	@test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1315 08366664 Michael Hanselmann
	if test -z "$(PEP8)"; then \
1316 08366664 Michael Hanselmann
		echo '"pep8" not found during configure' >&2; \
1317 08366664 Michael Hanselmann
	else \
1318 08366664 Michael Hanselmann
		$(PEP8) --repeat --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1319 21bf2e2e Andrea Spadaccini
			$(pep8_python_code); \
1320 08366664 Michael Hanselmann
	fi
1321 6d7cc5ff Michael Hanselmann
	$(PYLINT) $(LINT_OPTS) $(lint_python_code)
1322 3582eef6 Iustin Pop
	cd $(top_srcdir)/qa && \
1323 3582eef6 Iustin Pop
	  PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1324 3582eef6 Iustin Pop
	  --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1325 e0098923 Iustin Pop
1326 191ff68c Iustin Pop
.PHONY: hlint
1327 5a1e31b4 Iustin Pop
hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1328 191ff68c Iustin Pop
	if tty -s; then C="-c"; else C=""; fi; \
1329 3603605a Iustin Pop
	hlint --report=doc/hs-lint.html --cross $$C \
1330 3603605a Iustin Pop
	  --ignore "Use first" \
1331 3603605a Iustin Pop
	  --ignore "Use comparing" \
1332 3603605a Iustin Pop
	  --ignore "Use on" \
1333 3603605a Iustin Pop
	  --ignore "Use Control.Exception.catch" \
1334 3603605a Iustin Pop
	  --ignore "Reduce duplication" \
1335 5a1e31b4 Iustin Pop
	  --hint htools/lint-hints \
1336 3603605a Iustin Pop
	  $(filter-out htools/Ganeti/THH.hs,$(HS_LIB_SRCS))
1337 191ff68c Iustin Pop
1338 84a12e40 Iustin Pop
# a dist hook rule for updating the vcs-version file; this is
1339 84a12e40 Iustin Pop
# hardcoded due to where it needs to build the file...
1340 84a12e40 Iustin Pop
dist-hook:
1341 84a12e40 Iustin Pop
	$(MAKE) regen-vcs-version && \
1342 84a12e40 Iustin Pop
	rm -f $(top_distdir)/vcs-version && \
1343 84a12e40 Iustin Pop
	cp -p $(srcdir)/vcs-version $(top_distdir)
1344 84a12e40 Iustin Pop
1345 84a12e40 Iustin Pop
# a distcheck hook rule for catching revision control directories
1346 b6f2e47f Iustin Pop
distcheck-hook:
1347 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1348 c6aa0c42 Michael Hanselmann
		echo "Found revision control files in final archive." 1>&2; \
1349 c6aa0c42 Michael Hanselmann
		exit 1; \
1350 c6aa0c42 Michael Hanselmann
	fi
1351 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*.py[co]' | grep .; then \
1352 c6aa0c42 Michael Hanselmann
		echo "Found Python byte code in final archive." 1>&2; \
1353 c6aa0c42 Michael Hanselmann
		exit 1; \
1354 c6aa0c42 Michael Hanselmann
	fi
1355 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*~' | grep .; then \
1356 c6aa0c42 Michael Hanselmann
		echo "Found backup files in final archive." 1>&2; \
1357 b6f2e47f Iustin Pop
		exit 1; \
1358 b6f2e47f Iustin Pop
	fi
1359 bf0b21da Michael Hanselmann
# Empty files or directories should not be distributed. They can cause
1360 bf0b21da Michael Hanselmann
# unnecessary warnings for packagers. Directories used by automake during
1361 bf0b21da Michael Hanselmann
# distcheck must be excluded.
1362 bf0b21da Michael Hanselmann
	if find $(top_distdir) -empty -and -not \( \
1363 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_build -or \
1364 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_inst \) | grep .; then \
1365 bf0b21da Michael Hanselmann
		echo "Found empty files or directories in final archive." 1>&2; \
1366 bf0b21da Michael Hanselmann
		exit 1; \
1367 bf0b21da Michael Hanselmann
	fi
1368 c7b86f6c Michael Hanselmann
	if test -n "$(BUILD_RELEASE)" && \
1369 c7b86f6c Michael Hanselmann
	   grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1370 c7b86f6c Michael Hanselmann
		echo "Found unreleased version in NEWS." >&2; \
1371 c7b86f6c Michael Hanselmann
		exit 1; \
1372 c7b86f6c Michael Hanselmann
	fi
1373 c7b86f6c Michael Hanselmann
1374 c7b86f6c Michael Hanselmann
# When building a release, stricter checks should be used
1375 e627fe09 Michael Hanselmann
distcheck-release dist-release: export BUILD_RELEASE = 1
1376 c7b86f6c Michael Hanselmann
distcheck-release: distcheck
1377 b6f2e47f Iustin Pop
1378 e627fe09 Michael Hanselmann
dist-release: dist
1379 e627fe09 Michael Hanselmann
	set -e; \
1380 e627fe09 Michael Hanselmann
	for i in $(DIST_ARCHIVES); do \
1381 e627fe09 Michael Hanselmann
		echo -n "Checking $$i ... "; \
1382 e627fe09 Michael Hanselmann
		autotools/check-tar < $$i; \
1383 e627fe09 Michael Hanselmann
		echo OK; \
1384 e627fe09 Michael Hanselmann
	done
1385 e627fe09 Michael Hanselmann
1386 8925faaa Iustin Pop
install-exec-local:
1387 0d93b082 Michael Hanselmann
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1388 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
1389 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/run/ganeti"
1390 e8230860 Michael Hanselmann
1391 c964d962 Michael Hanselmann
# To avoid conflicts between directory names and other targets, a file inside
1392 c964d962 Michael Hanselmann
# the directory is used to ensure its existence.
1393 c964d962 Michael Hanselmann
%.dir:
1394 c964d962 Michael Hanselmann
	@mkdir_p@ $* && touch $@
1395 e8230860 Michael Hanselmann
1396 d128fdb6 Iustin Pop
.PHONY: apidoc
1397 a38bfce5 Iustin Pop
if WANT_HTOOLSAPIDOC
1398 a38bfce5 Iustin Pop
apidoc: py-apidoc hs-apidoc
1399 a38bfce5 Iustin Pop
else
1400 a38bfce5 Iustin Pop
apidoc: py-apidoc
1401 a38bfce5 Iustin Pop
endif
1402 a38bfce5 Iustin Pop
1403 a38bfce5 Iustin Pop
.PHONY: py-apidoc
1404 a38bfce5 Iustin Pop
py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1405 b959138f Michael Hanselmann
	$(RUN_IN_TEMPDIR) epydoc -v \
1406 b959138f Michael Hanselmann
		--conf $(CURDIR)/epydoc.conf \
1407 22c5390d Iustin Pop
		--output $(CURDIR)/$(APIDOC_PY_DIR)
1408 a38bfce5 Iustin Pop
1409 a38bfce5 Iustin Pop
.PHONY: hs-apidoc
1410 c3f67183 Iustin Pop
hs-apidoc: $(HS_BUILT_SRCS)
1411 a38bfce5 Iustin Pop
	@test -n "$(HSCOLOUR)" || \
1412 a38bfce5 Iustin Pop
	    { echo 'HsColour' not found during configure; exit 1; }
1413 a38bfce5 Iustin Pop
	@test -n "$(HADDOCK)" || \
1414 a38bfce5 Iustin Pop
	    { echo 'haddock' not found during configure; exit 1; }
1415 22c5390d Iustin Pop
	rm -rf $(APIDOC_HS_DIR)/*
1416 458a286a Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1417 358a0a8f Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1418 22c5390d Iustin Pop
	$(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1419 82888134 Michael Hanselmann
	$(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1420 358a0a8f Iustin Pop
	$(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1421 a38bfce5 Iustin Pop
	set -e ; \
1422 a38bfce5 Iustin Pop
	cd htools; \
1423 c478f837 Iustin Pop
	if [ "$(HTOOLS_NOCURL)" ]; \
1424 c478f837 Iustin Pop
	then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1425 c478f837 Iustin Pop
	else OPTGHC=""; \
1426 c478f837 Iustin Pop
	fi; \
1427 1adec4be Iustin Pop
	if [ "$(HTOOLS_PARALLEL3)" ]; \
1428 1adec4be Iustin Pop
	then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1429 1adec4be Iustin Pop
	fi; \
1430 606e71d3 Iustin Pop
	RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1431 a38bfce5 Iustin Pop
	for file in $$RELSRCS; do \
1432 a38bfce5 Iustin Pop
		hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1433 22c5390d Iustin Pop
		$(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1434 a38bfce5 Iustin Pop
	done ; \
1435 22c5390d Iustin Pop
	$(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1436 a38bfce5 Iustin Pop
		-t ganeti-htools -p haddock-prologue \
1437 a38bfce5 Iustin Pop
		--source-module="%{MODULE/.//}.html" \
1438 a38bfce5 Iustin Pop
		--source-entity="%{MODULE/.//}.html#%{NAME}" \
1439 c478f837 Iustin Pop
		$$OPTGHC \
1440 c3f67183 Iustin Pop
		$(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1441 d128fdb6 Iustin Pop
1442 13e720f1 Iustin Pop
.PHONY: TAGS
1443 eb732fb5 Michael Hanselmann
TAGS: $(BUILT_SOURCES)
1444 13e720f1 Iustin Pop
	rm -f TAGS
1445 74fa8200 Iustin Pop
	find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1446 74fa8200 Iustin Pop
	  -path './daemons/ganeti-*' -o -path './tools/*' -o \
1447 74fa8200 Iustin Pop
	  -path './qa/*.py' | \
1448 3bb5c580 Iustin Pop
	  etags -l python -
1449 13e720f1 Iustin Pop
1450 27e336af Michael Hanselmann
.PHONY: coverage
1451 b91e9518 Iustin Pop
if WANT_HTOOLS
1452 b91e9518 Iustin Pop
coverage: py-coverage hs-coverage
1453 b91e9518 Iustin Pop
else
1454 b91e9518 Iustin Pop
coverage: py-coverage
1455 b91e9518 Iustin Pop
endif
1456 b91e9518 Iustin Pop
1457 b91e9518 Iustin Pop
.PHONY: py-coverage
1458 b91e9518 Iustin Pop
py-coverage: $(BUILT_SOURCES) $(python_tests)
1459 27e336af Michael Hanselmann
	set -e; \
1460 22c5390d Iustin Pop
	COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1461 22c5390d Iustin Pop
	TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1462 22c5390d Iustin Pop
	HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1463 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1464 e8c8cf1a Michael Hanselmann
	$(python_tests)
1465 27e336af Michael Hanselmann
1466 b91e9518 Iustin Pop
.PHONY: hs-coverage
1467 896b2850 Iustin Pop
hs-coverage: $(haskell_tests) htools/hpc-htools
1468 25cdf177 Iustin Pop
	rm -f *.tix && $(MAKE) hs-check
1469 48f12e73 Iustin Pop
	@mkdir_p@ $(COVERAGE_HS_DIR)
1470 896b2850 Iustin Pop
	hpc combine $(HPCEXCL) test.tix hpc-htools.tix > coverage-htools.tix
1471 896b2850 Iustin Pop
	hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1472 896b2850 Iustin Pop
	hpc report coverage-htools.tix
1473 82888134 Michael Hanselmann
	$(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1474 b91e9518 Iustin Pop
1475 ec8379bd Iustin Pop
# Special "kind-of-QA" target for htools, needs special setup (all
1476 ec8379bd Iustin Pop
# tools compiled with -fhpc)
1477 ec8379bd Iustin Pop
.PHONY: live-test
1478 ec8379bd Iustin Pop
live-test: all
1479 ec8379bd Iustin Pop
	set -e ; \
1480 ec8379bd Iustin Pop
	cd htools; \
1481 82888134 Michael Hanselmann
	rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1482 ec8379bd Iustin Pop
	rm -f *.tix *.mix; \
1483 ec8379bd Iustin Pop
	./live-test.sh; \
1484 c3f67183 Iustin Pop
	hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1485 ec8379bd Iustin Pop
	  --output=live-test.tix ; \
1486 22c5390d Iustin Pop
	@mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1487 22c5390d Iustin Pop
	hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1488 ec8379bd Iustin Pop
		--srcdir=.. $(HPCEXCL) ; \
1489 ec8379bd Iustin Pop
	hpc report --srcdir=.. live-test $(HPCEXCL)
1490 b91e9518 Iustin Pop
1491 b341b9ca Guido Trotter
commit-check: distcheck lint apidoc
1492 b341b9ca Guido Trotter
1493 3baa809c Michael Hanselmann
-include ./Makefile.local
1494 3baa809c Michael Hanselmann
1495 e8230860 Michael Hanselmann
# vim: set noet :